var ajaxManager =
	{
		getTranslations: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.language_path + 'langue_' + windowUrl.getQueryString('lng') + '.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'xml';
				ajax_params['success'] = function(xml)
					{
						$(xml).find('menuitem').each(function()
							{
								translatorEngine.indexes['idx_' + $(this).attr('index')] = $(this).attr('label');
							});
						
						$('.loading_spinner_text').text(translatorEngine.indexes.idx_98);
						
						ajaxManager.getSecurity();
					};
				
				$.ajax(ajax_params);
			},
		
		getSecurity: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.path + 'security.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'text';
				ajax_params['success'] = function(text)
					{
						var xml = stringUtils.stringToXML(text.replace('&', '%26'));
						var credentials_list = $(xml).find('data');
						
						if (credentials_list.length == 0)
							{
								ajaxManager.handleSecurityRemoved();
							}
						else
							{
								componentsManager.hideLoadingSpinnerMain();
								componentsManager.showLoginPanel(credentials_list);
							}
					};
				ajax_params['error'] = function()
					{
						ajaxManager.handleSecurityRemoved();
					};
				
				$.ajax(ajax_params);
			},
		
		handleSecurityRemoved: function()
			{
				componentsManager.showScreenBlockerBusy();
				
				ajaxManager.getParams();
			},
		
		getParams: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.path + 'param.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'xml';
				ajax_params['success'] = function(xml)
					{
						app.setParametersFromXml($(xml).find('parameter'));
						ajaxManager.getMenu();
					};
				
				$.ajax(ajax_params);
			},
		
		getMenu: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.path + 'menu2.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'xml';
				ajax_params['success'] = function(xml)
					{
						$(xml).find('menuitem').each(function()
							{
								summaryManager.items.push({
									label: $(this).attr('label'),
									page_number: $(this).attr('numPage')
								});
							});
						
						ajaxManager.getMenuParams();
					};
				
				$.ajax(ajax_params);
			},
		
		getMenuParams: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.path + 'menuParam.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'xml';
				ajax_params['success'] = function(xml)
					{
						var menu_alpha = ((app.params.menu_alpha == undefined) ? 0 : parseFloat(app.params.menu_alpha.value)) / 100;
						
						if (Ext.os.is.Android && Ext.os.version.lt(3) && (menu_alpha < 0.5))
							{
								menu_alpha = 0.5;
							}
						
						imagesManager.special_icons_alpha = 1 - menu_alpha;
						
						var color_aux = stringUtils.hexToRGB('#' + stringUtils.prependPads($(xml).children('conf').attr('fond').substr(2), 6, '0'));
						
						app.color_background = 'rgba(' + color_aux.r + ', ' + color_aux.g + ', ' + color_aux.b + ', ' + menu_alpha + ')';
						app.color_foreground = '#' + stringUtils.prependPads($(xml).children('conf').attr('teinte').substr(2), 6, '0');
						
						$('#styles_fixed').append('.x-toolbar-dark {background: ' + app.color_background + ' !important;}');
						
						var color_aux = stringUtils.hexToRGB(app.color_foreground);
						var rgba = 'rgba(' + color_aux.r + ', ' + color_aux.g + ', ' + color_aux.b + ', .2)';
						
						$('#styles_fixed').append('.top_bar, .x-toolbar {border-color: ' + ((menu_alpha > 0) ? app.color_foreground : 'transparent') + ' !important;}');
						$('#styles_fixed').append('.x-field-slider .x-slider .x-field-thumb.x-field:before {background-color: ' + app.color_foreground + ' !important;}');
						
						var color_aux = stringUtils.hexToRGB(stringUtils.hexToHtml(app.params.coulFond.value));
						var color_style = 'rgb(' + (255 - parseInt(color_aux.r)) + ', ' + (255 - parseInt(color_aux.g)) + ', ' + (255 - parseInt(color_aux.b)) + ')';
						
						$('#page_number_panel').css('border-color', color_style + ' !important');
						$('#page_number_panel').css('background', 'rgba(' + color_aux.r + ', ' + color_aux.g + ', ' + color_aux.b + ', .85) !important');
						$('#page_number_panel').css('color', color_style + ' !important');
						
						componentsManager.createTopBar();
						
						topBarManager.xml = $(xml);
						
						topBarManager.loadLogo();
						topBarManager.loadSpecialIcons();
						topBarManager.loadCustomButtons('right');
						
						ajaxManager.getLinks();
					};
				
				$.ajax(ajax_params);
			},
		
		getLinks: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.path + 'liens.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'xml';
				ajax_params['success'] = function(xml)
					{
						$(xml).find('page').each(function()
							{
								var page_links = [];
								
								$(this).children('lien').each(function()
									{
										page_links.push({
											w: ~~$(this).attr('w'),
											h: ~~$(this).attr('h'),
											x: ~~$(this).attr('x'),
											y: ~~$(this).attr('y'),
											url: $(this).attr('url'),
											target: $(this).attr('target'),
											page: $(this).attr('page')
										});
									});
								
								linkManager.pages_links['page-' + $(this).attr('num')] = page_links;
							});
						
						app.applicationReady();
					};
				
				$.ajax(ajax_params);
			},
		
		shareWithFriend: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.postURL;
				ajax_params['type'] = 'POST';
				ajax_params['data'] = {
					coul: app.params.coulFond.value,
					id: windowUrl.getQueryString('id'),
					lng: windowUrl.getQueryString('lng'),
					mail1: document.getElementById('mail1').value,
					mail2: document.getElementById('mail2').value,
					message: document.getElementById('message').value,
					nom: document.getElementById('nom').value,
					result: '',
					url: windowUrl.buildShareUrl()
				};
				ajax_params['dataType'] = 'html';
				ajax_params['success'] = function()
					{
						visualComponents.share_with_friend.hide('pop');
						
						visualComponents.info_message_sent.show();
						
						new Ext.util.DelayedTask(function()
							{
								visualComponents.info_message_sent.hide();
							}).delay(1500);
					};
				ajax_params['error'] = function()
					{
						alert(translatorEngine.indexes.idx_56);
						
						componentsManager.hideShareWithFriend();
					};
				
				$.ajax(ajax_params);
			},
		
		getTexts: function()
			{
				var ajax_params = new Array();
				
				ajax_params['url'] = app.path + 'texte.xml';
				ajax_params['type'] = 'GET';
				ajax_params['dataType'] = 'xml';
				ajax_params['success'] = function(xml)
					{
						searchManager.texts = [];
						
						$(xml).find('page').each(function()
							{
								searchManager.texts.push({
									page_number: $(this).attr('num'),
									content: $.trim($(this).text())
								});
							});
						
						componentsManager.createSearchResultsPanel();
						
						searchManager.findText();
					};
				
				$.ajax(ajax_params);
			},
	};