var app =
	{
		params: {},
		link_opacity: .05,
		min_nr_pages_slider_visible: 20,
		color_background: null,
		color_foreground: null,
		postURL: '/v2/envoiAmi.jsp',
		path: null,
		language_path: null,
		title: null,
		
		applicationReady: function()
			{
				componentsManager.createShareWithFriend();
				componentsManager.createInfoMessageSent();
				
				componentsManager.createZoomPanel();
				componentsManager.createPagesPanel();
				componentsManager.createBottomBar();
				
				componentsManager.createVideoPanel();
				componentsManager.createAudioPanel();
				
				this.updateDimensions();
				
				visualComponents.pages_panel.show();
				cardManager.changeCard(cardManager.getCardNumberFromPageIndex(cardManager.start_page));
				
				componentsManager.hideScreenBlockerBusy();
			},
		
		urlReceived: function(url)
			{
				windowUrl.parse(url);
				
				this.setPath(windowUrl.getQueryString('id'));
				this.setLanguagePath(windowUrl.getQueryString('id'));
				this.setTitle(windowUrl.getQueryString('title'));
				
				imagesManager.preloadImage(this.path + 'Diapo/page1.jpg', topBarManager.evtOnLoadDiapo, topBarManager.evtOnErrorDiapo);
			},
		
		setOrientation: function(page_orientation)
			{
				proportionsManager.orientation = page_orientation;
				
				$('body').attr('class', proportionsManager.orientation + (this.params.onePage ? ' one-page' : ''));
			},
		
		getOrientationFromAngle: function(angle)
			{
				return (Math.abs(angle) == 90) ? 'landscape' : 'portrait';
			},
		
		setPath: function(id)
			{
				this.path = (id != undefined)
											? id + '/'
											: 'projet/';
			},
		
		setLanguagePath: function(id)
			{
				if (typeof(id) != 'undefined')
					{
						var tokens = id.split('/');
						var up_path = '';
						
						for (var i = 1; i < tokens.length; i++)
							{
								up_path += '../';
							}
						
						this.language_path = id + '/../' + up_path + 'mobile/lng/';
					}
				else
					{
						this.language_path = 'mobile/lng/';
					}
			},
		
		setTitle: function(title)
			{
				this.title = (title != undefined)
											 ? decodeURIComponent(title)
											 : '';
											 
				document.title = this.title;
			},
		
		setParametersFromXml: function(xml_params)
			{
				xml_params.each(function()
					{
						app.params[$(this).attr('name')] =
							{
								name: $(this).attr('name'),
								type: $(this).attr('type'),
								value: $(this).attr('value')
							};
					});
				
				cardManager.nr_pages = ~~this.params.nbPages.value;
				
				this.params.onePage = (this.params.onePage)
																? (~~this.params.onePage.value === 1)
																: false;
				
				if (this.params.onePage)
					{
						$('body').addClass('one-page');
					}
				
				proportionsManager.setImageMode('Small', parseInt(parseInt(this.params.widthS.value) / 2), this.params.heightS.value);
				proportionsManager.setImageMode('Big', parseInt(parseInt(this.params.widthB.value) / 2), this.params.heightB.value);
				proportionsManager.setImageMode('Big1', parseInt(parseInt(this.params.widthB1.value) / 2), this.params.heightB1.value);
				proportionsManager.setImageMode('Big2', parseInt(parseInt(this.params.widthB2.value) / 2), this.params.heightB2.value);
				proportionsManager.setImageMode('Zoom', parseInt(parseInt(this.params.imgLargeurZoom.value) / 2), this.params.imgHauteurZoom.value);
				
				proportionsManager.sortImageModes();
				
				if (this.params.coulLien)
					{
						var rgb = stringUtils.hexToRGB(stringUtils.hexToHtml(this.params.coulLien.value));
						this.params.coulLien.value = 'rgba(' + rgb.r + ', ' + rgb.g + ', ' + rgb.b + ', 1)';
						
						$('#styles_fixed').append('.link_page {border-color: ' + this.params.coulLien.value + '; background: ' + this.params.coulLien.value.replace(', 1)', ', ' + this.link_opacity + ')') + ';}');
						$('#styles_fixed').append('.link_zoom {border-color: ' + this.params.coulLien.value + '; background: ' + this.params.coulLien.value.replace(', 1)', ', ' + this.link_opacity + ')') + ';}');
					}
				
				if (this.params.coulFond)
					{
						$('#styles_fixed').append('#zoom_panel, body {background-color: ' + stringUtils.hexToHtml(this.params.coulFond.value) + ' !important;}');
						$('#styles_fixed').append('.sub-page {background-color: ' + stringUtils.hexToHtml(this.params.coulFond.value) + ' !important;}');
					}
				
				if (this.params.logo)
					{
						imagesManager.logo = this.params.logo.value;
					}
				
				componentsManager.createPageNumberPanel();
				
				cardManager.updateNrPagesPerCard();
				proportionsManager.calculateView();
			},
		
		clearDimensions: function()
			{
				$('#' + Ext.Viewport.getId()).css('height', '');
				
				$('.portrait_w').removeClass('portrait_w');
				$('.portrait_h').removeClass('portrait_h');
				$('.landscape_w').removeClass('landscape_w');
				$('.landscape_h').removeClass('landscape_h');
			},
		
		updateDimensions: function()
			{
				app.clearDimensions();
				
				$('#' + Ext.Viewport.getId()).addClass(proportionsManager.orientation + '_w').addClass(proportionsManager.orientation + '_h');
				$('#screen_blocker_translucent').addClass(proportionsManager.orientation + '_w').addClass(proportionsManager.orientation + '_h');
				$('#zoom_panel').addClass(proportionsManager.orientation + '_h');
				$('#pages_panel').addClass(proportionsManager.orientation + '_w').addClass(proportionsManager.orientation + '_h');
				$('#carousel_default').addClass(proportionsManager.orientation + '_w').addClass(proportionsManager.orientation + '_h');
				$('#top_bar').addClass(proportionsManager.orientation + '_w');
				$('#bottom_bar').addClass(proportionsManager.orientation + '_w');
				$('#carousel_thumbnails').addClass(proportionsManager.orientation + '_w');
				$('#card_slider').addClass(proportionsManager.orientation + '_w');
			},
		
		orientationChanged: function()
			{
				componentsManager.hideScreenBlockerTranslucent();
				componentsManager.showScreenBlockerBusy();
				
				setTimeout(function()
					{
						proportionsManager.updateOrientation();
						cardManager.updateNrPagesPerCard();
						
						if (Globals.auth_form_visible)
							{
								app.updateDimensions();
								
								componentsManager.hideScreenBlockerBusy();
								componentsManager.centerLoginPanel();
							}
						else
							{
								componentsManager.hideVideoPanel();
								componentsManager.hideAudioPanel();
								
								if (visualComponents.icon_showreel)
									{
										if (proportionsManager.orientation == 'portrait')
											{
												componentsManager.hideSpecialIcon('showreel');
											}
										else
											{
												componentsManager.showSpecialIcon('showreel');
											}
									}
								
								proportionsManager.calculateView();
								
								$('#input_text_search').blur();
								
								componentsManager.hideTopBar();
								componentsManager.hideBottomBar();
								
								if (visualComponents.gallery)
									{
										if (!visualComponents.gallery.opened)
											{
												$('#gallery').css('-webkit-transform', 'translate3d(-' + proportionsManager.screen_dimensions.w + 'px, 0, 0)');
											}
										else
											{
												setTimeout(function()
													{
														galleryManager.scrollToCurrentCard();
													},
													1000
												);
											}
									}
								
								if (visualComponents.summary &&
										!visualComponents.summary.opened)
									{
										$('#summary').css('-webkit-transform', 'translate3d(-' + proportionsManager.screen_dimensions.w + 'px, 0, 0)');
									}
								
								visualComponents.carousel_default.hide();
								cardManager.reloadCards();
								visualComponents.carousel_default.show();
								
								searchManager.resizeSearchPanel();
								
								app.updateDimensions();
								
								if (zoomManager.is_zoomed)
									{
										var current_scale_factor = zoomManager.current_scale_factor;
										
										zoomManager.zoomElement(undefined, undefined, current_scale_factor, false);
									}
								
								if (visualComponents.carousel_thumbnails)
									{
										visualComponents.carousel_thumbnails.show();
									}
								
								if (visualComponents.slider)
									{
										visualComponents.slider.show();
									}
								
								componentsManager.hideScreenBlockerBusy();
								
								if (visualComponents.search_panel)
									{
										if (visualComponents.search_panel.visible)
											{
												componentsManager.showScreenBlockerTranslucent('rgba(0, 0, 0, 0.3)');
												
												$('#search_panel').css('left', parseInt((proportionsManager.screen_dimensions.w - searchManager.search_panel_outer_width) / 2) + 'px !important');
											}
										else
											{
												visualComponents.search_panel.element.dom.style.webkitTransitionDuration = '0ms';
												$('#search_panel').css('-webkit-transform', 'translate3d(0, -' + proportionsManager.screen_dimensions.h + 'px, 0)');
												
												setTimeout(function()
													{
														visualComponents.search_panel.element.dom.style.webkitTransitionDuration = '350ms';
													},
													350
												);
											}
									}
								
								if (visualComponents.share_with_friend &&
										!visualComponents.share_with_friend.isHidden())
									{
										componentsManager.showScreenBlockerTranslucent('rgba(0, 0, 0, 0.3)');
										componentsManager.centerShareWithFriend();
									}
							}
					},
					500
				);
			}
	};