var cardManager =
	{
		nr_pages: null,
		nr_cards: null,
		first_page_index: null,
		start_page: null,
		current_card_number: null,
		nr_pages_per_card: null,
		
		changeCard: function(nr_card)
			{
				this.current_card_number = nr_card;
				this.start_page = (nr_card - parseInt(this.nr_pages_per_card / 2)) * this.nr_pages_per_card;
				
				Globals.carousel_event_cardSwitch_locked = true;
				
				var index = nr_card - 1;
				
				visualComponents.carousel_default.setActiveItem(index);
				
				if (!visualComponents.carousel_default.getItems().items[index].rendered)
					{
						visualComponents.carousel_default.setActiveItem(parseInt(this.nr_cards / 2));
						visualComponents.carousel_default.setActiveItem(index);
					}
				
				carouselDefaultManager.cardChanged(nr_card);
				
				Globals.carousel_event_cardSwitch_locked = false;
				
				zoomManager.updateContent(nr_card);
				
				if (visualComponents.carousel_thumbnails)
					{
						carouselThumbnailsManager.cardChanged(nr_card);
					}
				
				$('.div_diapo_carousel_thumbnails_selected').removeClass('div_diapo_carousel_thumbnails_selected');
				$('#div_diapo_carousel_thumbnails_' + nr_card).addClass('div_diapo_carousel_thumbnails_selected');
				
				$('.div_diapo_gallery_selected').removeClass('div_diapo_gallery_selected');
				$('#div_diapo_gallery_' + nr_card).addClass('div_diapo_gallery_selected');
				
				if (visualComponents.carousel_thumbnails)
					{
						carouselThumbnailsManager.scrollToCurrentCard(true);
					}
				
				if (visualComponents.slider)
					{
						Globals.slider_event_changed_locked = true;
						visualComponents.slider.setValue(this.current_card_number - 1);
						Globals.slider_event_changed_locked = false;
					}
				
				linkManager.displayCurrentCardLinks();
				
				windowUrl.changeHash('page', this.start_page);
				
				parent.postMessage(
					{
						action: 'pageChanged',
						params: {
							page: cardManager.start_page
						}
					},
					'*'
				);
			},
		
		reloadCards: function()
			{
				carouselDefaultManager.generateCarouselPages();
				
				if (visualComponents.carousel_thumbnails)
					{
						carouselThumbnailsManager.generateCarouselPages();
						carouselThumbnailsManager.attachCardsEvents();
					}
				
				if (visualComponents.gallery)
					{
						galleryManager.generateGalleryPages();
						galleryManager.attachCardsEvents();
					}
				
				if (visualComponents.slider)
					{
						visualComponents.slider.setMaxValue(this.nr_cards - 1);
						visualComponents.slider.setValues([0, this.nr_cards - 1]);
					}
				
				this.changeCard(this.getCardNumberFromPageIndex(this.start_page));
			},
		
		getCardNumberFromPageIndex: function(page_index)
			{
				return (this.nr_pages_per_card == 1)
								 ? page_index
								 : parseInt(page_index / 2) + 1;
			},
		
		updateNrPagesPerCard: function()
			{
				this.nr_pages_per_card = ((proportionsManager.orientation == 'portrait') || (app.params.onePage)) ? 1 : 2;
				
				if (visualComponents.icon_showreel)
					{
						$('#icon_showreel > img').attr('class', (this.nr_pages_per_card == 1) ? 'showreel_double' : 'showreel_single');
						$('#contour_showreel > img').attr('class', (this.nr_pages_per_card == 1) ? 'showreel_double' : 'showreel_single');
					}
				
				this.nr_cards = (this.nr_pages_per_card == 1)
													? this.nr_pages
													: 1 + parseInt((this.nr_pages - 1) / 2) + ((this.nr_pages - 1) % 2);
				
				this.first_page_index = this.nr_pages_per_card % 2;
				
				this.start_page = (this.nr_pages_per_card == 1)
														? ((this.start_page > 0) ? this.start_page : 1)
														: this.start_page - (this.start_page % 2);
				
				proportionsManager.calculateDimensions();
			},
		
		getPagesNumbersFromCardNumber: function(nr_card)
			{
				var result = [];
				
				if (this.nr_pages_per_card == 1)
					{
						result.push(nr_card);
					}
				else if (this.nr_pages_per_card == 2)
					{
						if ((nr_card == 1) || ((nr_card == this.nr_cards) && ((this.nr_pages % 2) == 0)))
							{
								result.push((nr_card == 1) ? 1 : (nr_card - 1) * 2);
							}
						else
							{
								var page_left_number = (nr_card - 1) * 2;
								
								result.push(page_left_number);
								result.push(page_left_number + 1);
							}
					}
				
				return result;
			},
		
		getLabelPagesNumbersFromCardNumber: function(nr_card)
			{
				var pages_numbers = this.getPagesNumbersFromCardNumber(nr_card);
				
				return pages_numbers.join('-');
			},
	};