var carouselDefaultManager =
	{
		queue_size: /*2*/3,
		cards_load_status: null,
		
		initCardsLoadStatus: function()
			{
				this.cards_load_status = new Array(cardManager.nr_cards + 1);
				
				for (var i = 0; i < this.cards_load_status; i++)
					{
						this.cards_load_status[i] = false;
					}
			},
		
		generateCarouselPages: function()
			{
				visualComponents.carousel_default.suspendEvents();
				visualComponents.carousel_default.removeAll();
				
				this.initCardsLoadStatus();
				
				var start_stop_cards = this.calculateStartStopCard(cardManager.getCardNumberFromPageIndex(cardManager.start_page));
				
				var start_card = start_stop_cards[0];
				var stop_card = start_stop_cards[1];
				
				for (var i = start_card; i <= stop_card; i++)
					{
						visualComponents.carousel_default.add(this.createCardItem(i, this.generateCardItemHtml(i)));
					}
				
				for (var i = 1; i < start_card; i++)
					{
						visualComponents.carousel_default.insert(i - 1, this.createCardItem(i, this.generateCardItemHtml(i, true)));
					}
				
				for (var i = (stop_card + 1); i <= cardManager.nr_cards; i++)
					{
						visualComponents.carousel_default.insert(i, this.createCardItem(i, this.generateCardItemHtml(i, true)));
					}
				
				visualComponents.carousel_default.resumeEvents();
			},
		
		createCardItem: function(nr_card, html_content)
			{
				var result = Ext.create('Ext.Panel', {
					id: 'page_panel_' + nr_card,
					fullscreen: false,
					html: html_content
				});
				
				result.show();
				
				return result;
			},
		
		generateCardItemHtml: function(nr_card, blank)
			{
				blank = (blank != undefined) ? blank : false;
				
				if (blank)
					{
						var left = parseInt((proportionsManager.stage.w - 120) / 2);
						var top = parseInt((proportionsManager.stage.h - 70) / 2);
						
						var loading_spinner = componentsManager.createLoadingSpinner(translatorEngine.indexes.idx_98,
																																				 'position: absolute; z-index: 13; left: ' + left + 'px; top: ' + top + 'px;');
						
						var content = '';
						
						for (var i = 0; i < cardManager.nr_pages_per_card; i++)
							{
								content += '<div class="page-img page_loading" onmousedown="return false;">' +
														 loading_spinner +
													 '</div>';
							}
					}
				else
					{
						var image_sources = this.getImagesSourcesFromCardNumber(nr_card);
						
						var content = '<img src="' + image_sources[0] + '" class="page-img" onmousedown="return false;" />' +
													'<img src="' + image_sources[1] + '" class="page-img" onmousedown="return false;" />';
					}
				
				var result = '<div class="page" id="page-' + nr_card + '">' +
											 '<div class="sub-page" id="sub-page-' + nr_card + '">' +
											 	 content +
											 '</div>' +
										 '</div>';
				
				if (!blank)
					{
						this.cards_load_status[nr_card] = true;
					}
				
				return result;
			},
		
		getImagesSourcesFromCardNumber: function(nr_card)
			{
				var result = new Array(2);
				
				var obj_image = new Image();
				var image_index_start = (cardManager.nr_pages_per_card == 1) ? nr_card : (nr_card - 1) * 2;
				
				for (var i = 0; i < cardManager.nr_pages_per_card; i++)
					{
						var image_number = image_index_start + i;
						
						result[i] = ((image_number > 0) && (image_number <= cardManager.nr_pages))
													? app.path + proportionsManager.current_image_mode + '/page' + image_number + '.jpg'
													: imagesManager.image_blank;
													
						obj_image.src = result[i];
					}
				
				if (cardManager.nr_pages_per_card == 1)
					{
						result[1] = imagesManager.image_blank;
					}
				
				return result;
			},
		
		calculateStartStopCard: function(nr_card)
			{
				var result = new Array(2);
				
				var current_card_offset = this.getCardOffsetFromCardNumber(nr_card);
				
				result[0] = nr_card - current_card_offset;
				result[1] = result[0] + this.queue_size * 2;
				
				if (result[1] > cardManager.nr_cards)
					{
						result[1] = cardManager.nr_cards;
					}
				
				return result;
			},
		
		getCardOffsetFromCardNumber: function(nr_card)
			{
				var offset = 0;
				
				for (var i = 1; i <= this.queue_size; i++)
					{
						if (nr_card <= i)
							{
								return offset;
							}
						
						offset += 1;
					}
				
				for (var i = (cardManager.nr_cards - this.queue_size + 1); i <= cardManager.nr_cards; i++)
					{
						if (nr_card < i)
							{
								return offset;
							}
						
						offset += 1;
					}
				
				if ((offset + 1) >= cardManager.nr_cards)
					{
						offset = cardManager.nr_cards - 1;
					}
				
				return offset;
			},
		
		getCardOffsetFromPageIndex: function(page_index)
			{
				return this.getCardOffsetFromCardNumber(cardManager.getCardNumberFromPageIndex(page_index));
			},
		
		cardChanged: function(nr_card)
			{
				var start_stop_cards = this.calculateStartStopCard(nr_card);
				
				var start_card = start_stop_cards[0];
				var stop_card = start_stop_cards[1];
				
				for (var i = start_card; i <= stop_card; i++)
					{
						if (!this.cards_load_status[i])
							{
								visualComponents.carousel_default.getItems().items[i - 1].setHtml(this.generateCardItemHtml(i));
							}
					}
			}
	};