var carouselThumbnailsManager =
	{
		card_width: null,
		nr_cards_visible: null,
		scroll_offset_x_min: 0,
		scroll_offset_x_max: null,
		
		generateCarouselPages: function()
			{
				var html_content = '<div id="div_thumbnails_container_carousel" style="height: ' + (proportionsManager.image_modes.Diapo.h + 16 + 1) + 'px;">' +
														 '<div class="div_spacer_carousel_thumbnails" style="height: ' + proportionsManager.image_modes.Diapo.h + 'px;"></div>';
				
				var start_stop_cards = this.calculateStartStopCard(cardManager.getCardNumberFromPageIndex(cardManager.start_page));
				this.scroll_offset_x_max = 0;
				
				for (var i = 1; i <= cardManager.nr_cards; i++)
					{
						html_content += this.createCardItem(i, start_stop_cards);
					}
				
				html_content += 	'<div class="div_spacer_carousel_thumbnails" style="height: ' + proportionsManager.image_modes.Diapo.h + 'px;"></div>' +
												'</div>';
				
				this.scroll_offset_x_max += 8 * 2 - proportionsManager.screen_dimensions.w;
				
				visualComponents.carousel_thumbnails.setHtml(html_content);
			},
		
		createCardItem: function(nr_card, interval)
			{
				var in_interval = false;
				var image_sources = [imagesManager.image_blank, imagesManager.image_blank];
				
				if (numberUtils.inInterval(nr_card, interval))
					{
						in_interval = true;
						image_sources = this.getImagesSourcesFromCardNumber(nr_card);
					}
				
				var is_first_page_invisible = ((image_sources[0] == imagesManager.image_blank) && ((in_interval || (!in_interval && (nr_card == 1))) && (cardManager.nr_pages_per_card == 2))) ? true : false;
				var is_last_page_invisible = ((image_sources[1] == imagesManager.image_blank) && (in_interval || (!in_interval && ((nr_card == cardManager.nr_cards) && ((cardManager.nr_pages % 2) == 0))) || (cardManager.nr_pages_per_card == 1))) ? true : false;
				
				if (cardManager.nr_pages_per_card == 1)
					{
						this.scroll_offset_x_max += this.card_width;
					}
				else if (cardManager.nr_pages_per_card == 2)
					{
						if (is_first_page_invisible || is_last_page_invisible)
							{
								this.scroll_offset_x_max += proportionsManager.image_modes.Diapo.w + 8 * 2;
							}
						else
							{
								this.scroll_offset_x_max += this.card_width;
							}
					}
				
				var html_content = '<div id="div_diapo_carousel_thumbnails_' + nr_card + '" class="div_diapo_carousel_thumbnails ' + ((cardManager.current_card_number == nr_card) ? 'div_diapo_carousel_thumbnails_selected' : '') + '">' +
														 '<div style="width: ' + (is_first_page_invisible ? '0' : proportionsManager.image_modes.Diapo.w) + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px;">' +
														 	 '<img src="' + image_sources[0] + '" ' + (is_first_page_invisible ? 'style="width: 0px;"' : '') + ' onmousedown="return false;" />' +
														 '</div>' +
														 
														 '<div style="width: ' + (is_last_page_invisible ? '0' : proportionsManager.image_modes.Diapo.w) + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px;">' +
														 	 '<img src="' + image_sources[1] + '" ' + (is_last_page_invisible ? 'style="width: 0px;"' : '') + ' onmousedown="return false;" />' +
														 '</div>' +
													 '</div>';
				
				return html_content;
			},
		
		getImagesSourcesFromCardNumber: function(nr_card)
			{
				var result = new Array(2);
				
				var obj_image = new Image();
				
				var image_index_start = (cardManager.nr_pages_per_card == 1) ? nr_card : (nr_card - 1) * 2;
				
				for (var i = 0; i < cardManager.nr_pages_per_card; i++)
					{
						var image_number = image_index_start + i;
						
						result[i] = ((image_number > 0) && (image_number <= cardManager.nr_pages))
													? app.path + 'Diapo/page' + image_number + '.jpg'
													: imagesManager.image_blank;
													
						obj_image.src = result[i];
					}
				
				if (cardManager.nr_pages_per_card == 1)
					{
						result[1] = imagesManager.image_blank;
					}
				
				return result;
			},
		
		calculateStartStopCard: function(nr_card)
			{
				var result = new Array(2);
				
				result[0] = parseInt(nr_card) - (this.nr_cards_visible - 1) * 2;
				result[1] = parseInt(nr_card) + (this.nr_cards_visible - 1) * 2;
				
				if (result[0] < 1)
					{
						result[0] = 1;
					}
				
				if (result[1] > cardManager.nr_cards)
					{
						result[1] = cardManager.nr_cards;
					}
				
				return result;
			},
		
		attachCardsEvents: function()
			{
				$('.div_diapo_carousel_thumbnails').each(function()
					{
						var el = Ext.get($(this).attr('id'));
						
						el.removeListener('singletap');
						
						el.addListener('singletap', function()
							{
								var nr_card = $(this).attr('id').substr('div_diapo_carousel_thumbnails_'.length);
								
								if (cardManager.current_card_number != nr_card)
									{
										cardManager.changeCard(nr_card);
									}
							});
					});
			},
		
		cardChanged: function(nr_card)
			{
				var start_stop_cards = this.calculateStartStopCard(nr_card);
				
				for (var i = start_stop_cards[0]; i <= start_stop_cards[1]; i++)
					{
						image_sources = this.getImagesSourcesFromCardNumber(i);
						
						for (var pos = 0; pos < image_sources.length; pos++)
							{
								if (image_sources[pos] != imagesManager.image_blank)
									{
										var img = $('#div_diapo_carousel_thumbnails_' + i + ' > div:nth-child(' + (pos + 1) + ') > img');
										
										if (img.attr('src') == imagesManager.image_blank)
											{
												img.attr('src', image_sources[pos]);
											}
									}
							}
					}
			},
		
		nrPagesPerCardChanged: function()
			{
				this.card_width = proportionsManager.image_modes.Diapo.w * cardManager.nr_pages_per_card + 8 * 2;
				
				this.nr_cards_visible = parseInt(proportionsManager.screen_dimensions.w / this.card_width) + 2;
			},
		
		calculateScrollXFromCardNumber: function(nr_card)
			{
				if (cardManager.nr_pages_per_card == 1)
					{
						var result = (nr_card - 1) * (proportionsManager.image_modes.Diapo.w + 8 * 2) - parseInt((proportionsManager.screen_dimensions.w - proportionsManager.image_modes.Diapo.w) / 2) + 8 + 8;
					}
				else if (cardManager.nr_pages_per_card == 2)
					{
						var result = nr_card * (proportionsManager.image_modes.Diapo.w * 2 + 8 * 2) - proportionsManager.image_modes.Diapo.w * 2 - parseInt(proportionsManager.screen_dimensions.w / 2);
					}
				
				return result;
			},
		
		calculateCardNumberFromScrollX: function(x_scroll)
			{
				var pos = x_scroll + parseInt(proportionsManager.screen_dimensions.w / 2) - 8;
				
				if (cardManager.nr_pages_per_card == 2)
					{
						pos -= (proportionsManager.image_modes.Diapo.w + 8 * 2);
					}
				
				var result = parseInt(pos / this.card_width);
				var remainder = pos % this.card_width;
				
				if ((cardManager.nr_pages_per_card == 1) &&
						(remainder > 0))
					{
						result += 1;
					}
				else if ((cardManager.nr_pages_per_card == 2) &&
								 ((proportionsManager.image_modes.Diapo.w + 8 * 2) > remainder))
					{
						result -= 1;
					}
				
				return result;
			},
		
		scrollToCurrentCard: function(animate)
			{
				var scroll_offset_x = this.calculateScrollXFromCardNumber(cardManager.current_card_number);
				
				if (scroll_offset_x < this.scroll_offset_x_min)
					{
						scroll_offset_x = this.scroll_offset_x_min;
					}
				else if (scroll_offset_x > this.scroll_offset_x_max)
					{
						scroll_offset_x = this.scroll_offset_x_max;
					}
				
				visualComponents.carousel_thumbnails.getScrollable().getScroller().scrollTo(scroll_offset_x, 0, animate);
			}
	};