var componentsManager =
	{
		createLoadingSpinner: function(text, style)
			{
				text = (text != undefined) ? text : '';
				style = (style != undefined) ? style : '';
				
				var result = '<div class="loading_spinner" style="' + style + '">' +
											 '<div class="loading_spinner_animation">' +
												 '<div class="x-loading-spinner">' +
													 '<span class="x-loading-top"></span>' +
													 '<span class="x-loading-right"></span>' +
													 '<span class="x-loading-bottom"></span>' +
													 '<span class="x-loading-left"></span>' +
												 '</div>' +
												 
												 '<div class="loading_spinner_text">' + text + '</div>' +
											 '</div>' +
										 '</div>';
				
				return result;
			},
		
		createLoadingSpinnerMain: function()
			{
				var html_content = componentsManager.createLoadingSpinner();
				
				visualComponents.loading_spinner_main = Ext.create('Ext.Panel', {
					id: 'loading_spinner_main',
					style: 'width: 120px; height: 70px; position: absolute;',
					fullscreen: false,
					
					html: html_content
				});
			},
		
		showLoadingSpinnerMain: function()
			{
				$('#loading_spinner_main').css('left', parseInt((proportionsManager.screen_dimensions.w - 120) / 2) + 'px');
				$('#loading_spinner_main').css('top', parseInt((proportionsManager.screen_dimensions.h - 70) / 2) + 'px');
				
				visualComponents.loading_spinner_main.show();
			},
		
		hideLoadingSpinnerMain: function()
			{
				visualComponents.loading_spinner_main.hide();
			},
		
		showScreenBlockerBusy: function()
			{
				componentsManager.showScreenBlockerTranslucent('#000000');
				componentsManager.showLoadingSpinnerMain();
			},
		
		hideScreenBlockerBusy: function()
			{
				componentsManager.hideScreenBlockerTranslucent();
				componentsManager.hideLoadingSpinnerMain();
			},
		
		createScreenBlockerTranslucent: function()
			{
				visualComponents.screen_blocker_translucent = Ext.create('Ext.Panel', {
					id: 'screen_blocker_translucent',
					fullscreen: false,
					
					listeners:
						{
							painted: function()
								{
									$('#screen_blocker_translucent').removeClass('x-fullscreen');
								}
						}
				});
				
				visualComponents.screen_blocker_translucent.hide();
				
				visualComponents.screen_blocker_translucent.element.addListener('tap', function()
					{
						componentsManager.hideShareWithFriend();
						componentsManager.hideSearchPanel();
						componentsManager.hideVideoPanel();
						componentsManager.hideAudioPanel();
					});
			},
		
		showScreenBlockerTranslucent: function(bg_color)
			{
				$('#screen_blocker_translucent').css('background-color',	bg_color + ' !important')
																				.css('z-index', zoomManager.is_zoomed ? 20 : 10);
				
				$('#screen_blocker_translucent').show();
			},
		
		hideScreenBlockerTranslucent: function()
			{
				$('#screen_blocker_translucent').hide();
			},
		
		createLoginButton: function(creadentials_list)
			{
				visualComponents.login_button = Ext.create('Ext.Button', {
					renderTo: 'form_authentication_button_holder',
					text: translatorEngine.indexes.idx_59,
					style: 'display: inline-block; width: 50%; float: none;',
					ui: 'action',
					flex: 1,
					layout: 'hbox'
				});
				
				visualComponents.login_button.element.addListener('singletap', function()
					{
						var errors = [];
						
						creadentials_list.each(function(i)
							{
								if (($(this).attr('login') == $('#login').attr('value')) &&
										($(this).attr('password') == $('#pass').attr('value')))
									{
										componentsManager.hideLoginPanel();
										ajaxManager.handleSecurityRemoved();
										
										return;
									}
								else
									{
										errors.push(i);
									}
							});
						
						if (creadentials_list.length == errors.length)
							{
								alert(translatorEngine.indexes.idx_56);
								
								$('#login').attr('value', '');
								$('#pass').attr('value', '');
							}
					});
			},
		
		centerLoginPanel: function()
			{
				var top = parseInt((proportionsManager.screen_dimensions.h - visualComponents.login_panel.getHeight()) / 2);
				
				$('#login_panel').css('left', parseInt((proportionsManager.screen_dimensions.w - visualComponents.login_panel.getWidth()) / 2) + 'px !important')
												 .css('top', ((top > 0) ? top : 0) + 'px !important');
			},
		
		showLoginPanel: function(creadentials_list)
			{
				visualComponents.login_panel = Ext.create('Ext.Panel', {
					id: 'login_panel',
					cls: 'x-floating',
					width: 320,
					height: 128,
					draggable: false,
					fullscreen: false,
					centered: false,
					layout: 'fit',
					showAnimation: 'pop',
					hideAnimation: 'popOut',
					zIndex: 11,
					style: 'background-color: #999999 !important;',
					contentEl: 'form_authentication'
				});
				
				componentsManager.createLoginButton(creadentials_list);
				translatorEngine.translateElement(visualComponents.login_panel.config.contentEl);
				
				Ext.get('login').addListener('keydown', function(e)
					{
						if (e.event.keyCode == 13)
							{
								visualComponents.login_button.element.fireEvent('singletap');
							}
					});
				
				Ext.get('pass').addListener('keydown', function(e)
					{
						if (e.event.keyCode == 13)
							{
								visualComponents.login_button.element.fireEvent('singletap');
							}
					});
				
				componentsManager.centerLoginPanel();
				
				Globals.auth_form_visible = true;
				componentsManager.showScreenBlockerTranslucent('#000000');
				visualComponents.login_panel.show();
			},
		
		hideLoginPanel: function()
			{
				$('#login').blur();
				$('#pass').blur();
				
				visualComponents.login_panel.hide();
				componentsManager.hideScreenBlockerTranslucent();
				Globals.auth_form_visible = false;
			},
		
		createScreenBlockerModal: function()
			{
				visualComponents.screen_blocker_modal = {
					modal: true,
					centered: true,
					width: Globals.is_Phone ? 130 : 200,
					height: Globals.is_Phone ? 25 : 50,
					layout: 'fit'
				};
			},
		
		createVideoPanel: function()
			{
				visualComponents.video_panel = Ext.create('Ext.Panel', {
					draggable: false,
					fullscreen: false,
					centered: true,
					layout: 'fit',
					showAnimation: 'pop',
					contentEl: 'popup_video',
					
					listeners:
						{
							painted: function()
								{
									this.removeListener('hide');
									
									this.addListener('hide', function()
										{
											$('#popup_video')[0].pause();
										});
								}
						}
				});
				
				visualComponents.video_panel.hide();
				visualComponents.video_panel.setHideAnimation('popOut');
				
				visualComponents.video_panel.setSize(Globals.is_Phone ? 300 : 500,
																						 Globals.is_Phone ? 200 : 350);
				
				Ext.Viewport.add(visualComponents.video_panel);
			},
		
		showVideoPanel: function()
			{
				visualComponents.video_panel.setSize(Globals.is_Phone ? 300 : 500,
																						 Globals.is_Phone ? 200 : 350);
				
				var dimensions_fit = sizeUtils.scaleDimensionsToFitWindow(visualComponents.video_panel.getWidth(),
																																	visualComponents.video_panel.getHeight(),
																																	proportionsManager.screen_dimensions.w,
																																	proportionsManager.screen_dimensions.h);
				
				visualComponents.video_panel.setSize(dimensions_fit.width, dimensions_fit.height);
				
				componentsManager.showScreenBlockerTranslucent('rgba(0, 0, 0, 0.3)');
				
				visualComponents.video_panel.show();
				
				$('#popup_video')[0].is_playing = false;
				
				Ext.get('popup_video').addListener('tap', function(e)
					{
						if (!this.dom.is_playing)
							{
								this.dom.play();
								this.dom.is_playing = true;
							}
						else
							{
								this.dom.pause();
								this.dom.is_playing = false;
							}
						
						e.preventDefault();
						e.stopPropagation();
						
						return false;
					});
			},
		
		hideVideoPanel: function()
			{
				componentsManager.hideScreenBlockerTranslucent();
				
				if (visualComponents.video_panel)
					{
						visualComponents.video_panel.hide();
					}
			},
		
		createAudioPanel: function()
			{
				visualComponents.audio_panel = Ext.create('Ext.Panel', {
					draggable: false,
					fullscreen: false,
					centered: true,
					layout: 'fit',
					showAnimation: 'pop',
					contentEl: 'popup_audio',
					width: 0,
					height: 0,
					
					listeners:
						{
							painted: function()
								{
									this.removeListener('hide');
									
									this.addListener('hide', function()
										{
											$('#popup_audio')[0].pause();
										});
								}
						}
				});
				
				visualComponents.audio_panel.hide();
				visualComponents.audio_panel.setHideAnimation('popOut');
				
				visualComponents.audio_panel.setSize(Globals.is_Phone ? 260 : 350,
																						 60);
				
				Ext.Viewport.add(visualComponents.audio_panel);
			},
		
		showAudioPanel: function()
			{
				componentsManager.showScreenBlockerTranslucent('rgba(0, 0, 0, 0.3)');
				
				visualComponents.audio_panel.show();
				
				$('#popup_audio')[0].is_playing = false;
				
				Ext.get('popup_audio').addListener('tap', function(e)
					{
						if (!this.dom.is_playing)
							{
								this.dom.play();
								this.dom.is_playing = true;
							}
						else
							{
								this.dom.pause();
								this.dom.is_playing = false;
							}
						
						e.preventDefault();
						e.stopPropagation();
						
						return false;
					});
				
				$('#popup_audio')[0].play();
			},
		
		hideAudioPanel: function()
			{
				componentsManager.hideScreenBlockerTranslucent();
				
				if (visualComponents.audio_panel)
					{
						visualComponents.audio_panel.hide();
					}
			},
		
		createZoomPanel: function()
			{
				var html_content = '<div id="zoom_container_scaled">' +
														 '<img src="' + imagesManager.image_blank + '" id="img_zoom_0" class="img_zoom" />' +
														 '<img src="' + imagesManager.image_blank + '" id="img_zoom_1" class="img_zoom" />' +
													 '</div>';
				
				visualComponents.zoom_panel = Ext.create('Ext.Panel', {
					id: 'zoom_panel',
					fullscreen: false,
					cls: 'zoom_panel zoom_panel_invisible',
					
					html: html_content
				});
				
				visualComponents.zoom_panel.element.addListener('doubletap', function(e)
					{
						zoomManager.unZoomElement();
					});
				
				visualComponents.zoom_panel.element.addListener('touchstart', function(e)
					{
						zoomManager.translationBegin(e.touches, e.timeStamp);
					});
				
				visualComponents.zoom_panel.element.addListener('touchmove', function(e)
					{
						zoomManager.translateElement(e.touches, e.timeStamp);
					});
				
				visualComponents.zoom_panel.element.addListener('touchend', function(e)
					{
						zoomManager.translationEnd(e.touch.identifier, e.timeStamp);
					});
				
				visualComponents.zoom_panel.element.addListener('pinchstart', function(e)
					{
						zoomManager.rescalingBegin(e.touches);
					});
				
				visualComponents.zoom_panel.element.addListener('pinch', function(e)
					{
						zoomManager.rescaleElement(e.touches, e.scale, e.timestamp);
					});
				
				visualComponents.zoom_panel.element.addListener('pinchend', function(e)
					{
						zoomManager.rescalingEnd();
					});
				
				visualComponents.zoom_panel.show();
			},
		
		createPagesPanel: function()
			{
				visualComponents.pages_panel = Ext.create('Ext.Panel', {
					id: 'pages_panel',
					baseCls: '',
					width: proportionsManager.screen_dimensions.w,
					fullscreen: false
				});
				
				componentsManager.createCarouselDefault();
				
				visualComponents.pages_panel.element.addListener('singletap', function(e)
					{
						if (visualComponents.top_bar.visible ||
								visualComponents.bottom_bar.visible)
							{
								if (visualComponents.top_bar.visible)
									{
										componentsManager.hideTopBar();
									}
								
								if (visualComponents.bottom_bar.visible)
									{
										componentsManager.hideBottomBar();
									}
							}
						else
							{
								if (!visualComponents.top_bar.visible)
									{
										componentsManager.showTopBar();
									}
								
								if (!visualComponents.bottom_bar.visible)
									{
										componentsManager.showBottomBar();
									}
							}
					});
				
				visualComponents.pages_panel.element.addListener('doubletap', function(e)
					{
						zoomManager.zoomElement(e.pageX, e.pageY);
					});
				
				visualComponents.pages_panel.element.addListener('pinchstart', function(e)
					{
						visualComponents.pages_panel.hide();
						zoomManager.showZoomPanel();
						componentsManager.hideTopBar();
						componentsManager.hideBottomBar();
					});
				
				visualComponents.pages_panel.element.addListener('pinch', function(e)
					{
						if (e.scale > 1)
							{
								var center_x = parseInt((e.touches[0].pageX + e.touches[1].pageX) / 2);
								var center_y = parseInt((e.touches[0].pageY + e.touches[1].pageY) / 2);
								
								zoomManager.zoomElement(center_x, center_y);
							}
					});
			},
		
		showPagesPanel: function()
			{
				$('#pages_panel').css('-webkit-transform', 'translate3d(0, 0, 0)');
			},
		
		hidePagesPanel: function()
			{
				$('#pages_panel').css('-webkit-transform', 'translate3d(' + proportionsManager.screen_dimensions.w + 'px, 0, 0)');
			},
		
		createPageNumberPanel: function()
			{
				var html_content = '<span>1</span> / ' + cardManager.nr_pages;
				
				visualComponents.page_number_panel = Ext.create('Ext.Panel', {
					id: 'page_number_panel',
					fullscreen: false,
					
					html: html_content
				});
				
				$('#page_number_panel').css('top', '-60px');
				
				visualComponents.page_number_panel.show();
			},
		
		showPageNumberPanel: function(nr_card)
			{
				var label_pages_numbers = cardManager.getLabelPagesNumbersFromCardNumber(nr_card);
				
				$('#page_number_panel').find('span:first-child').text(label_pages_numbers);
				$('#page_number_panel').css('left', parseInt((proportionsManager.screen_dimensions.w - $('#page_number_panel').width() - 26) / 2) + 'px');
				$('#page_number_panel').css('top', parseInt((proportionsManager.screen_dimensions.h - $('#page_number_panel').height() - 26) / 2) + 'px');
				
				$('#page_number_panel').removeClass('invisible');
			},
		
		hidePageNumberPanel: function()
			{
				$('#page_number_panel').addClass('invisible');
			},
		
		createCarouselDefault: function()
			{
				visualComponents.carousel_default = Ext.create('Ext.carousel.Carousel', {
					id: 'carousel_default',
					fullscreen: false,
					indicator: false,
					bufferSize: /*1*//*2*/3,
					
					listeners:
						{
							activeitemchange: function()
								{
									if (Ext.os.is('Android') && this.isPainted())
										{
											var item_current = $('#' + visualComponents.carousel_default.getActiveItem().getId()).parent();
											/*
											item_current.siblings().each(function()
												{
													var webkit_transform = $(this).css('-webkit-transform');
													
													$(this).addClass('invisible');
													var self = $(this);
													
													setTimeout(function()
														{
															self.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
															
															setTimeout(function()
																{
																	self.css('-webkit-transform', webkit_transform);
																	
																	setTimeout(function()
																		{
																			self.removeClass('invisible');
																		},
																		10
																	);
																},
																10
															);
														},
														1
													);
												});
											*/
											var index = visualComponents.carousel_default.getActiveIndex();
											var index_previous = index - 1;
											var index_previous_before = index - 2;
											var index_previous_before_before = index - 3;
											var index_next = index + 1;
											var index_next_after = index + 2;
											var index_next_after_after = index + 3;
											
											item_current.css('z-index', 1);
											
											if (index_previous >= 0)
												{
													var item_previous = $('#' + visualComponents.carousel_default.getItems().items[index_previous].getId()).parent();
													
													item_previous.css('z-index', 0);
													
													setTimeout(function()
														{
															item_previous.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
														},
														1
													);
												}
											
											if (index_next <= this.getMaxItemIndex())
												{
													var item_next = $('#' + visualComponents.carousel_default.getItems().items[index_next].getId()).parent();
													
													item_next.css('z-index', 0);
													
													setTimeout(function()
														{
															item_next.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
														},
														1
													);
												}
											
											if (index_previous_before >= 0)
												{
													var item_previous_before = $('#' + visualComponents.carousel_default.getItems().items[index_previous_before].getId()).parent();
													
													item_previous_before.css('z-index', 0);
													
													setTimeout(function()
														{
															item_previous_before.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
														},
														1
													);
												}
											
											if (index_next_after <= this.getMaxItemIndex())
												{
													var item_next_after = $('#' + visualComponents.carousel_default.getItems().items[index_next_after].getId()).parent();
													
													item_next_after.css('z-index', 0);
													
													setTimeout(function()
														{
															item_next_after.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
														},
														1
													);
												}
											
											if (index_previous_before_before >= 0)
												{
													var item_previous_before_before = $('#' + visualComponents.carousel_default.getItems().items[index_previous_before_before].getId()).parent();
													
													item_previous_before_before.css('z-index', 0);
													
													setTimeout(function()
														{
															item_previous_before_before.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
														},
														1
													);
												}
											
											if (index_next_after_after <= this.getMaxItemIndex())
												{
													var item_next_after_after = $('#' + visualComponents.carousel_default.getItems().items[index_next_after_after].getId()).parent();
													
													item_next_after_after.css('z-index', 0);
													
													setTimeout(function()
														{
															item_next_after_after.css('-webkit-transform', 'translate3d(0px, 0px, 0px)');
														},
														1
													);
												}
										}
									
									if (!Globals.carousel_event_cardSwitch_locked)
										{
											cardManager.changeCard(this.getActiveIndex() + 1);
										}
								}
						}
				});
				
				carouselDefaultManager.generateCarouselPages();
				visualComponents.pages_panel.add(visualComponents.carousel_default);
				
				visualComponents.carousel_default.show();
			},
		
		createSpecialIconsPanels: function()
			{
				visualComponents.special_icons_panel = Ext.create('Ext.Panel', {
					id: 'special_icons_panel',
					fullscreen: false,
					
					defaults:
						{
							ui: 'mask'
						}
				});
				
				visualComponents.special_contours_panel = Ext.create('Ext.Panel', {
					id: 'special_contours_panel',
					fullscreen: false,
					
					defaults:
						{
							ui: 'mask'
						}
				});
				
				visualComponents.special_icons_panel.renderTo('container_special_icons_panels');
				visualComponents.special_contours_panel.renderTo('container_special_icons_panels');
			},
		
		createSpecialIcon: function(icon_name, singletap_action, icon_class)
			{
				icon_class = (icon_class == undefined) ? icon_name : icon_class;
				
				if (Ext.os.is.Android && Ext.os.version.lt(3))
					{
						var img_src = 'mobile/img/' + icon_class + '_icon.png';
					}
				else
					{
						var img_src = imagesManager.image_blank;
					}
				
				visualComponents['icon_' + icon_name] = Ext.create('Ext.Panel', {
					cls: 'special_icon',
					html: '<div id="icon_' + icon_name + '" class="container_special_icon" style="' + topBarManager.height + 'px;">' +
									'<img src="' + img_src + '" class="' + icon_class + '" style="height: ' + topBarManager.height + 'px;" />' +
								'</div>',
					
					listeners:
						{
							painted: function()
								{
									var el = Ext.get('icon_' + icon_name);
									
									el.removeListener('singletap');
									
									el.addListener('singletap', singletap_action);
								}
						}
				});
				
				visualComponents['contour_' + icon_name] = Ext.create('Ext.Panel', {
					cls: 'special_icon',
					html: '<div id="contour_' + icon_name + '" class="container_special_icon" style="' + topBarManager.height + 'px;">' +
									'<img src="' + img_src + '" class="' + icon_class + '" style="height: ' + topBarManager.height + 'px;" />' +
								'</div>'
				});
				
				imagesManager.preloadImage('mobile/img/' + icon_class + '_icon.png',
																	 topBarManager.evtOnLoadSpecialIcon,
																	 topBarManager.evtOnErrorSpecialIcon,
																	 {name: icon_name, icon_class: icon_class});
			},
		
		showSpecialIcon: function(icon_name)
			{
				visualComponents['icon_' + icon_name].show();
				visualComponents['contour_' + icon_name].show();
				
				topBarManager.special_icons_hidden -= 1;
			},
		
		hideSpecialIcon: function(icon_name)
			{
				visualComponents['icon_' + icon_name].hide();
				visualComponents['contour_' + icon_name].hide();
				
				topBarManager.special_icons_hidden += 1;
			},
		
		createIconSummary: function()
			{
				componentsManager.createSummary();
				
				componentsManager.createSpecialIcon('summary', function(e)
					{
						e.stopPropagation();
						
						if (visualComponents.summary &&
								visualComponents.summary.opened)
							{
								new Ext.util.DelayedTask(function()
									{
										componentsManager.hideSummary();
									}).delay(200);
							}
						else
							{
								new Ext.util.DelayedTask(function()
									{
										componentsManager.showSummary();
									}).delay(200);
							}
					});
			},
		
		createIconGallery: function()
			{
				componentsManager.createGallery();
				
				componentsManager.createSpecialIcon('gallery', function(e)
					{
						e.stopPropagation();
						
						if (visualComponents.gallery.opened)
							{
								var task = Ext.create('Ext.util.DelayedTask', function()
									{
										componentsManager.hideGallery();
									});
								
								task.delay(200);
							}
						else
							{
								var task = Ext.create('Ext.util.DelayedTask', function()
									{
										componentsManager.showGallery();
									});
								
								task.delay(200);
							}
					});
			},
		
		createIconMail: function()
			{
				componentsManager.createSpecialIcon('mail', function(e)
					{
						e.stopPropagation();
						
						componentsManager.showShareWithFriend();
					});
			},
		
		createIconShowreel: function()
			{
				var icon_visible = (cardManager.nr_pages_per_card == 1) ? 'double' : 'single';
				var icon_hidden = (cardManager.nr_pages_per_card == 1) ? 'single' : 'double';
				
				componentsManager.createSpecialIcon('showreel', function(e)
					{
						e.stopPropagation();
						
						if (proportionsManager.orientation == 'landscape')
							{
								app.params.onePage = !app.params.onePage;
								
								cardManager.updateNrPagesPerCard();
								proportionsManager.calculateView();
								
								cardManager.reloadCards();
							}
					},
					'showreel_' + icon_visible
				);
				
				imagesManager.preloadImage('mobile/img/showreel_' + icon_hidden + '_icon.png',
																	 topBarManager.evtOnLoadSpecialIconHidden,
																	 topBarManager.evtOnErrorSpecialIconHidden,
																	 {name: 'showreel',
																	  icon_class: 'showreel_' + icon_hidden});
				
				if (proportionsManager.orientation == 'portrait')
					{
						componentsManager.hideSpecialIcon('showreel');
					}
			},
		
		createShareWithFriend: function()
			{
				visualComponents.share_with_friend = Ext.create('Ext.Panel', {
					id: 'panel_share_with_friend',
					cls: 'x-floating',
					width: 320,
					height: 216,
					draggable: false,
					fullscreen: false,
					centered: false,
					layout: 'fit',
					showAnimation: 'pop',
					contentEl: 'send_to_friend',
					zIndex: 11,
					style: 'background-color: #000000 !important;'
				});
				
				componentsManager.createSendButton();
				componentsManager.createCancelButton();
				
				Ext.get('mail1').addListener('keydown', function(e)
					{
						if (e.event.keyCode == 13)
							{
								visualComponents.send_button.element.fireEvent('singletap');
							}
					});
				
				Ext.get('nom').addListener('keydown', function(e)
					{
						if (e.event.keyCode == 13)
							{
								visualComponents.send_button.element.fireEvent('singletap');
							}
					});
				
				Ext.get('mail2').addListener('keydown', function(e)
					{
						if (e.event.keyCode == 13)
							{
								visualComponents.send_button.element.fireEvent('singletap');
							}
					});
				
				visualComponents.share_with_friend.hide();
				visualComponents.share_with_friend.setHideAnimation('popOut');
				
				translatorEngine.translateElement(visualComponents.share_with_friend.config.contentEl);
			},
		
		centerShareWithFriend: function()
			{
				var top = parseInt((proportionsManager.screen_dimensions.h - visualComponents.share_with_friend.getHeight()) / 2);
				
				$('#panel_share_with_friend').css('left', parseInt((proportionsManager.screen_dimensions.w - visualComponents.share_with_friend.getWidth()) / 2) + 'px !important')
																		 .css('top', ((top > 0) ? top : 0) + 'px !important');
			},
		
		showShareWithFriend: function()
			{
				componentsManager.hideTopBar();
				componentsManager.hideBottomBar();
				
				componentsManager.showScreenBlockerTranslucent('rgba(0, 0, 0, 0.3)');
				
				windowUrl.changeHash('state', 'share');
				
				componentsManager.centerShareWithFriend();
				
				visualComponents.share_with_friend.show();
			},
		
		hideShareWithFriend: function()
			{
				if (visualComponents.icon_mail &&
						visualComponents.share_with_friend &&
						!visualComponents.share_with_friend.isHidden())
					{
						windowUrl.changeHash('state', '');
						
						$('#mail1').blur();
						$('#nom').blur();
						$('#mail2').blur();
						$('#message').blur();
						
						visualComponents.share_with_friend.hide();
						
						setTimeout(function()
							{
								componentsManager.hideScreenBlockerTranslucent();
							},
							250
						);
					}
			},
		
		createInfoMessageSent: function()
			{
				this.createScreenBlockerModal();
				
				visualComponents.info_message_sent = Ext.create('Ext.Panel', {
					items: [
						{
							xtype: 'panel',
							html: '<div id="" style="padding: 10px 0;font-size:.8em; text-align:center;">' + translatorEngine.indexes.idx_20 + '</div>'
						}
					]
				});
			},
		
		createSendButton: function()
			{
				visualComponents.send_button = Ext.create('Ext.Button', {
					renderTo: 'send_to_friend_button_holder',
					text: translatorEngine.indexes.idx_18,
					style: 'display: inline-block; width: 40%; margin-right: 10%;',
					ui: 'action',
					flex: 1,
					layout: 'hbox'
				});
				
				visualComponents.send_button.element.addListener('singletap', function()
					{
						window.scrollTo(0, 0);
						
						ajaxManager.shareWithFriend();
					});
			},
		
		createCancelButton: function()
			{
				visualComponents.cancel_button = Ext.create('Ext.Button', {
					renderTo: 'send_to_friend_button_holder',
					style: 'display: inline-block; width: 40%;',
					text: translatorEngine.indexes.idx_60,
					flex: 1,
					layout: 'hbox'
				});
				
				visualComponents.cancel_button.element.addListener('singletap', function()
					{
						componentsManager.hideShareWithFriend();
					});
			},
		
		centerToolbarPanels: function()
			{
				var hidden_icons_width = topBarManager.special_icons_hidden * topBarManager.special_icon_width;
				
				$('#container_special_icons_panels').css('width', (topBarManager.icon_containers_widths.middle - hidden_icons_width) + 'px');
				
				var panel_left_w = $('#container_custom_buttons_LEFT').width();
				var panel_middle_w = $('#container_custom_buttons_MIDDLE').width();
				var panel_right_w = $('#container_custom_buttons_RIGHT').width();
				
				if ((panel_left_w > 0) || (panel_middle_w > 0) || (panel_right_w > 0))
					{
						var panel_middle_left = parseInt((proportionsManager.screen_dimensions.w - panel_middle_w - 8) / 2);
						
						panel_middle_left = (panel_middle_left < 0) ? 0 : panel_middle_left;
						panel_middle_left = (panel_middle_left < (panel_left_w + 8)) ? (panel_left_w + 16) : panel_middle_left;
						
						$('#container_custom_buttons_MIDDLE').css('left', panel_middle_left + 'px');
					}
			},
		
		createTopToolbar: function()
			{
				var html_content = '<div id="container_custom_buttons_LEFT" class="container_custom_buttons"></div>' +
													 
													 '<div id="container_custom_buttons_MIDDLE" class="container_custom_buttons">' +
													 	 '<div id="container_special_icons_panels"></div>' +
													 '</div>' +
													 
													 '<div id="container_custom_buttons_RIGHT" class="container_custom_buttons"></div>';
													 
				visualComponents.top_toolbar = Ext.create('Ext.Toolbar', {
						id: 'top_toolbar',
						docked: 'top',
						type: 'dark',
						html: html_content,
						
						layout: {
							type: 'fit',
							align: 'start',
							pack: 'start'
						},
						
						defaults:
							{
								ui: 'mask'
							}
					});
			},
		
		createTopBar: function()
			{
				componentsManager.createTopToolbar();
				
				visualComponents.top_bar = Ext.create('Ext.Panel', {
					id: 'top_bar',
					cls: 'top_bar',
					baseCls: '',
					fullscreen: false,
					visible: false,
					items: [visualComponents.top_toolbar]
				});
				
				visualComponents.top_bar.show();
				
				visualComponents.top_bar.element.addListener('singletap', function(e)
					{
						var x = e.pageX;
						var y = e.pageY;
						
						
					});
			},
		
		showTopBar: function()
			{
				visualComponents.top_bar.show();
				
				componentsManager.centerToolbarPanels();
				
				visualComponents.top_bar.element.dom.style.webkitTransform = 'translate3d(0, 0, 0)';
				visualComponents.top_bar.visible = true;
			},
		
		hideTopBar: function()
			{
				visualComponents.top_bar.element.dom.style.webkitTransform = 'translate3d(0, -' + topBarManager.height + 'px, 0)';
				visualComponents.top_bar.visible = false;
				
				setTimeout(function()
					{
						visualComponents.top_bar.hide();
					},
					250
				);
			},
		
		createCarouselThumbnails: function()
			{
				visualComponents.carousel_thumbnails = Ext.create('Ext.Panel', {
					id: 'carousel_thumbnails',
					fullscreen: false,
					style: 'height: ' + (proportionsManager.image_modes.Diapo.h + 16 + 1) + 'px !important; white-space: nowrap; overflow: hidden; background-color: rgba(0, 0, 0, 0.75) !important;',
					
					scrollable: {
		        direction: 'horizontal'
					},
					
					defaults: {
						layout: {
							align: 'start',
							pack: 'start'
						},
						
						style: 'text-align: center;	vertical-align: middle;'
					},
					
					listeners:
						{
							initialize: function()
								{
									this.getScrollable().getScroller().addListener('scrollend', function(self, offset_x, offset_y)
										{
											var nr_card_middle = carouselThumbnailsManager.calculateCardNumberFromScrollX(offset_x);
											carouselThumbnailsManager.cardChanged(nr_card_middle);
										});
								},
							
							painted: function()
								{
									carouselThumbnailsManager.attachCardsEvents();
								}
						}
				});
				
				carouselThumbnailsManager.generateCarouselPages();
				visualComponents.bottom_bar.add(visualComponents.carousel_thumbnails);
				
				visualComponents.carousel_thumbnails.show();
			},
		
		createSlider: function()
			{
				visualComponents.slider = Ext.create('Ext.slider.Slider', {
					id: 'card_slider',
					fullscreen: false,
					minValue: 0,
					maxValue: cardManager.nr_cards - 1,
					values: [0, cardManager.nr_cards - 1],
					
					layout:
						{
							type: 'hbox',
							pack: 'center',
							align: 'stretch'
						},
					
					listeners:
						{
							change: function(self, thumb, new_value, old_value)
								{
									if (!Globals.slider_event_changed_locked)
										{
											cardManager.changeCard(new_value + 1);
										}
								},
							
							drag: function()
								{
									componentsManager.showPageNumberPanel(parseInt(this.getValue()) + 1);
								},
							
							dragend: function()
								{
									componentsManager.hidePageNumberPanel();
								}
						}
				});
				
				visualComponents.bottom_bar.add(visualComponents.slider);
				visualComponents.slider.show();
			},
		
		createBottomBar: function()
			{
				visualComponents.bottom_bar = Ext.create('Ext.Panel', {
					id: 'bottom_bar',
					baseCls: '',
					fullscreen: false,
					style: '-webkit-transform: translate3d(0, ' + proportionsManager.screen_dimensions.h + 'px, 0);',
					visible: false,
					
					layout: {
						type: 'vbox',
						align: 'start',
						pack: 'start'
					}
				});
				
				if (!Globals.is_Phone)
					{
						componentsManager.createCarouselThumbnails();
					}
				
				if (cardManager.nr_pages >= app.min_nr_pages_slider_visible)
					{
						componentsManager.createSlider();
					}
				
				visualComponents.bottom_bar.hide();
			},
		
		showBottomBar: function()
			{
				visualComponents.bottom_bar.show();
				
				var carousel_thumbnails_height = 0;
				
				if (visualComponents.carousel_thumbnails)
					{
						carouselThumbnailsManager.scrollToCurrentCard(false);
						carousel_thumbnails_height = visualComponents.carousel_thumbnails.element.getHeight();
					}
				
				var slider_height = (visualComponents.slider) ? visualComponents.slider.element.getHeight() : 0;
				
				visualComponents.bottom_bar.element.dom.style.webkitTransform = 'translate3d(0, ' + (proportionsManager.screen_dimensions.h - (carousel_thumbnails_height + slider_height)) + 'px, 0)';
				visualComponents.bottom_bar.visible = true;
			},
		
		hideBottomBar: function()
			{
				visualComponents.bottom_bar.element.dom.style.webkitTransform = 'translate3d(0, ' + proportionsManager.screen_dimensions.h + 'px, 0)';
				visualComponents.bottom_bar.visible = false;
				
				setTimeout(function()
					{
						visualComponents.bottom_bar.hide();
					},
					250
				);
			},
		
		createGallery: function()
			{
				visualComponents.gallery = Ext.create('Ext.Panel', {
					id: 'gallery',
					baseCls: '',
					fullscreen: false,
					opened: false,
					style: 'background-color: ' + stringUtils.hexToHtml(app.params.coulFond.value) + ' !important; -webkit-transform: translate3d(-100%, 0, 0);',
					styleHtmlContent: true,
					styleHtmlCls: '',
					
					scrollable: {
						direction: 'vertical'
					},
					
					is_scrolling: false,
					
					defaults: {
						layout: {
							type: 'hbox',
							align: 'center',
							pack: 'center'
						},
						
						style: 'text-align: center;	vertical-align: middle;'
					},
					
					listeners:
						{
							initialize: function()
								{
									this.getScrollable().getScroller().addListener('scrollend', function(self, offset_x, offset_y)
										{
											var nr_card_middle = galleryManager.calculateCardNumberFromScrollY(offset_y);
											galleryManager.cardChanged(nr_card_middle);
										});
								},
							
							painted: function()
								{
									galleryManager.attachCardsEvents();
								}
						}
				});
				
				galleryManager.generateGalleryPages();
				
				visualComponents.gallery.hide();
			},
		
		showGallery: function()
			{
				componentsManager.hideTopBar();
				componentsManager.hideBottomBar();
				componentsManager.hidePagesPanel();
				
				windowUrl.changeHash('state', 'gallery');
				
				visualComponents.gallery.show();
				galleryManager.scrollToCurrentCard();
				$('#gallery').css('-webkit-transform', 'translate3d(0, 0, 0)');
				visualComponents.gallery.opened = true;
				
				if (visualComponents.summary &&
						visualComponents.summary.opened)
					{
						componentsManager.hideSummary();
					}
			},
		
		hideGallery: function()
			{
				if ((visualComponents.icon_gallery != null) &&
						visualComponents.gallery.opened)
					{
						windowUrl.changeHash('state', '');
						
						visualComponents.gallery.opened = false;
						$('#gallery').css('-webkit-transform', 'translate3d(-' + proportionsManager.screen_dimensions.w + 'px, 0, 0)');
						
						componentsManager.showPagesPanel();
						
						setTimeout(function()
							{
								visualComponents.gallery.hide();
							},
							500
						);
					}
			},
		
		createSummary: function()
			{
				visualComponents.summary = Ext.create('Ext.dataview.List', {
					id: 'summary',
					fullscreen: false,
					singleSelect: true,
					pinHeaders: false,
					opened: false,
					itemTpl: '<div id="summary_item_{page_number}">{label} - ' + translatorEngine.indexes.idx_93 + ' {page_number}</div>',
					store: summaryManager.generateSummaryItems(),
					style: 'white-space: nowrap; background-color: ' + stringUtils.hexToHtml(app.params.coulFond.value) + ' !important;',
					
					listeners:
						{
							selectionchange: function(oList, el)
								{
									if (el.length == 1)
										{
											cardManager.changeCard(cardManager.getCardNumberFromPageIndex(parseInt(el[0].data.page_number)));
											
											componentsManager.hideSummary();
										}
								}
						}
				});
				
				visualComponents.summary.hide();
			},
		
		showSummary: function()
			{
				componentsManager.hideTopBar();
				componentsManager.hideBottomBar();
				componentsManager.hidePagesPanel();
				
				windowUrl.changeHash('state', 'summary');
				
				visualComponents.summary.show();
				$('#summary').css('-webkit-transform', 'translate3d(0, 0, 0)');
				visualComponents.summary.opened = true;
				
				if (visualComponents.gallery &&
						visualComponents.gallery.opened)
					{
						componentsManager.hideGallery();
					}
			},
		
		hideSummary: function()
			{
				if ((visualComponents.icon_summary != null) &&
						visualComponents.summary.opened)
					{
						windowUrl.changeHash('state', '');
						
						visualComponents.summary.opened = false;
						$('#summary').css('-webkit-transform', 'translate3d(-' + proportionsManager.screen_dimensions.w + 'px, 0, 0)');
						
						componentsManager.showPagesPanel();
						
						setTimeout(function()
							{
								visualComponents.summary.hide();
							},
							500
						);
					}
			},
		
		createIconSearch: function()
			{
				componentsManager.createSearchPanel();
				
				componentsManager.createSpecialIcon('search', function(e)
					{
						e.stopPropagation();
						
						componentsManager.showSearchPanel();
					});
			},
		
		createSearchResultsPanel: function()
			{
				visualComponents.search_results_panel = Ext.create('Ext.Panel', {
					id: 'search_results_panel',
					fullscreen: false,
					width: 286,
					centered: true,
					style: 'overflow: hidden;',
					
					scrollable: {
						direction: 'vertical'
					},
					
					is_scrolling: false,
					
					defaults: {
						layout: {
							type: 'vbox',
							align: 'start',
							pack: 'start'
						}
					}
				});
				
				visualComponents.search_results_panel.renderTo('search_results');
			},
		
		createSearchPanel: function()
			{
				visualComponents.search_panel = Ext.create('Ext.Panel', {
					id: 'search_panel',
					fullscreen: false,
					width: searchManager.search_panel_outer_width,
					height: 60,
					contentEl: 'form_search',
					style: '-webkit-transform: translate3d(0, -120%, 0);',
					visible: false
				});
				
				visualComponents.search_panel.show();
			},
		
		showSearchPanel: function()
			{
				componentsManager.showScreenBlockerTranslucent('rgba(0, 0, 0, 0.3)');
				
				componentsManager.hideTopBar();
				componentsManager.hideBottomBar();
				
				windowUrl.changeHash('state', 'search');
				
				$('#form_search_controls').addClass('invisible');
				$('#search_panel').css('left', parseInt((proportionsManager.screen_dimensions.w - searchManager.search_panel_outer_width) / 2) + 'px !important');
				visualComponents.search_panel.element.dom.style.webkitTransform = 'translate3d(0, 0, 0)';
				visualComponents.search_panel.visible = true;
				
				setTimeout(function()
					{
						if (visualComponents.gallery &&
								visualComponents.gallery.opened)
							{
								componentsManager.hideGallery();
							}
						
						if (visualComponents.summary &&
								visualComponents.summary.opened)
							{
								componentsManager.hideSummary();
							}
						
						$('#form_search_controls').removeClass('invisible');
					},
					400
				);
			},
		
		hideSearchPanel: function()
			{
				if ((visualComponents.icon_search != null) &&
						visualComponents.search_panel.visible)
					{
						windowUrl.changeHash('state', '');
						
						$('#input_text_search').blur();
						
						setTimeout(function()
							{
								visualComponents.search_panel.visible = false;
								visualComponents.search_panel.element.dom.style.webkitTransform = 'translate3d(0, ' + (-visualComponents.search_panel.getHeight() - 8) + 'px, 0)';
								
								setTimeout(function()
									{
										componentsManager.hideScreenBlockerTranslucent();
										visualComponents.search_panel.element.dom.style.webkitTransitionDuration = '350ms';
									},
									350
								);
							},
							100
						);
					}
			}
	};