var galleryManager =
	{
		card_width: null,
		card_height: null,
		nr_cards_per_row: null,
		nr_cards_per_column: null,
		nr_rows: null,
		nr_cards_visible: null,
		cards_load_status: null,
		gallery_height: null,
		
		initCardsLoadStatus: function()
			{
				this.cards_load_status = new Array(cardManager.nr_cards + 1);
				
				for (var i = 0; i < this.cards_load_status; i++)
					{
						this.cards_load_status[i] = false;
					}
			},
		
		generateGalleryPages: function()
			{
				this.initCardsLoadStatus();
				
				var item_width = proportionsManager.image_modes.Diapo.w * cardManager.nr_pages_per_card + 16 * 2;
				
				var html_content = '<div id="div_thumbnails_container_gallery" style="width: ' + (item_width * Math.floor(proportionsManager.screen_dimensions.w / item_width)) + 'px;">';
				
				var start_stop_cards = this.calculateStartStopCard(cardManager.getCardNumberFromPageIndex(cardManager.start_page));
				
				for (var i = 1; i <= cardManager.nr_cards; i++)
					{
						html_content += this.createGalleryItem(i, start_stop_cards);
					}
				
				html_content += '</div>';
				
				visualComponents.gallery.setHtml(html_content);
			},
		
		createGalleryItem: function(nr_card, interval)
			{
				var image_sources = [imagesManager.image_blank, imagesManager.image_blank];
				
				if (numberUtils.inInterval(nr_card, interval))
					{
						image_sources = this.getImagesSourcesFromCardNumber(nr_card);
						this.cards_load_status[nr_card] = true;
					}
				
				var color_bg = stringUtils.hexToRGB(stringUtils.hexToHtml(app.params.coulFond.value));
				var color_style = 'rgb(' + (255 - parseInt(color_bg.r)) + ', ' + (255 - parseInt(color_bg.g)) + ', ' + (255 - parseInt(color_bg.b)) + ')';
				
				if (cardManager.nr_pages_per_card == 1)
					{
						var html_content = '<div id="div_diapo_gallery_' + nr_card + '" class="div_diapo_gallery ' + ((cardManager.current_card_number == nr_card) ? 'div_diapo_gallery_selected' : '') + '" style="color: ' + color_style + ';">' +
																 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + (proportionsManager.image_modes.Diapo.h + 20) + 'px;">' +
																	 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; background-color: ' + color_style + ';">' +
																	 	 '<img src="' + image_sources[0] + '" onmousedown="return false;" />' +
																	 '</div>' +
																	 
																	 '<div class="div_diapo_gallery_text" style="width: ' + proportionsManager.image_modes.Diapo.w + 'px;">' +
																 	 	 translatorEngine.indexes.idx_93 + ' ' + nr_card +
																 	 '</div>' +
																 '</div>' +
															 '</div>';
					}
				else if (cardManager.nr_pages_per_card == 2)
					{
						if (nr_card == 1)
							{
								var html_content = '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; float: left; display: inline;"></div>' +
																	 
																	 '<div id="div_diapo_gallery_' + nr_card + '" class="div_diapo_gallery ' + ((cardManager.current_card_number == nr_card) ? 'div_diapo_gallery_selected' : '') + '" style="color: ' + color_style + ';">' +
																		 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + (proportionsManager.image_modes.Diapo.h + 20) + 'px; float: left; display: inline;">' +
																			 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; background-color: ' + color_style + ';">' +
																			 	 '<img src="' + image_sources[1] + '" onmousedown="return false;" />' +
																			 '</div>' +
																			 
																			 '<div class="div_diapo_gallery_text" style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; ">' +
																			 	 translatorEngine.indexes.idx_93 + ' ' + ((nr_card - 1) * 2 + 1) +
																		 	 '</div>' +
																		 '</div>' +
																	 '</div>';
							}
						else if (nr_card == cardManager.nr_cards)
							{
								var html_content = '<div id="div_diapo_gallery_' + nr_card + '" class="div_diapo_gallery ' + ((cardManager.current_card_number == nr_card) ? 'div_diapo_gallery_selected' : '') + '" style="color: ' + color_style + ';">' +
																		 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + (proportionsManager.image_modes.Diapo.h + 20) + 'px; float: left; display: inline;">' +
																			 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; background-color: ' + color_style + ';">' +
																			 	 '<img src="' + image_sources[0] + '" onmousedown="return false;" />' +
																			 '</div>' +
																			 
																			 '<div class="div_diapo_gallery_text" style="width: ' + proportionsManager.image_modes.Diapo.w + 'px;">' +
																			 	 translatorEngine.indexes.idx_93 + ' ' + ((nr_card - 1) * 2) +
																			 '</div>' +
																		 '</div>' +
																	 '</div>' +
																	 
																	 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; float: left; display: inline;"></div>';
							}
						else
							{
								var html_content = '<div id="div_diapo_gallery_' + nr_card + '" class="div_diapo_gallery ' + ((cardManager.current_card_number == nr_card) ? 'div_diapo_gallery_selected' : '') + '" style="color: ' + color_style + ';">' +
																		 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + (proportionsManager.image_modes.Diapo.h + 20) + 'px; float: left; display: inline;">' +
																			 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; background-color: ' + color_style + ';">' +
																			 	 '<img src="' + image_sources[0] + '" onmousedown="return false;" />' +
																			 '</div>' +
																			 
																			 '<div class="div_diapo_gallery_text" style="width: ' + proportionsManager.image_modes.Diapo.w + 'px;">' +
																			 	 translatorEngine.indexes.idx_93 + ' ' + ((nr_card - 1) * 2) +
																			 '</div>' +
																		 '</div>' +
																		 
																		 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + (proportionsManager.image_modes.Diapo.h + 20) + 'px; float: left; display: inline;">' +
																			 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; background-color: ' + color_style + ';">' +
																			 	 '<img src="' + image_sources[1] + '" onmousedown="return false;" />' +
																			 '</div>' +
																			 
																			 '<div class="div_diapo_gallery_text" style="width: ' + proportionsManager.image_modes.Diapo.w + 'px;">' +
																			 	 translatorEngine.indexes.idx_93 + ' ' + ((nr_card - 1) * 2 + 1) +
																		 	 '</div>' +
																		 '</div>' +
																	 '</div>';
							}
					}
				
				return html_content;
			},
		
		getImagesSourcesFromCardNumber: function(nr_card)
			{
				var result = new Array(2);
				
				var obj_image = new Image();
				
				var image_index_start = (cardManager.nr_pages_per_card == 1) ? nr_card : (nr_card - 1) * 2;
				
				for (var i = 0; i < cardManager.nr_pages_per_card; i++)
					{
						var image_number = image_index_start + i;
						
						result[i] = ((image_number > 0) && (image_number <= cardManager.nr_pages))
													? app.path + 'Diapo/page' + image_number + '.jpg'
													: imagesManager.image_blank;
													
						obj_image.src = result[i];
					}
				
				if (cardManager.nr_pages_per_card == 1)
					{
						result[1] = imagesManager.image_blank;
					}
				
				return result;
			},
		
		calculateStartStopCard: function(nr_card)
			{
				var result = new Array(2);
				
				result[0] = parseInt(nr_card) - this.nr_cards_visible;
				result[1] = parseInt(nr_card) + this.nr_cards_visible;
				
				if (result[0] < 1)
					{
						result[0] = 1;
					}
				
				if (result[1] > cardManager.nr_cards)
					{
						result[1] = cardManager.nr_cards;
					}
				
				return result;
			},
		
		attachCardsEvents: function()
			{
				$('.div_diapo_gallery').each(function()
					{
						var el = Ext.get($(this).attr('id'));
						
						el.removeListener('singletap');
						
						el.addListener('singletap', function()
							{
								var nr_card = $(this).attr('id').substr('div_diapo_gallery_'.length);
								
								if (cardManager.current_card_number != nr_card)
									{
										cardManager.changeCard(nr_card);
									}
								
								componentsManager.hideGallery();
							});
					});
			},
		
		cardChanged: function(nr_card)
			{
				var start_stop_cards = this.calculateStartStopCard(nr_card);
				
				var start_card = start_stop_cards[0];
				var stop_card = start_stop_cards[1];
				
				for (var i = start_card; i <= stop_card; i++)
					{
						if (!this.cards_load_status[i])
							{
								image_sources = this.getImagesSourcesFromCardNumber(i);
								
								if ((cardManager.nr_pages_per_card == 2) &&
										(i == 1))
									{
										$('#div_diapo_gallery_' + i + ' img:first').attr('src', image_sources[1]);
									}
								else
									{
										$('#div_diapo_gallery_' + i + ' img').each(function(j)
											{
												$(this).attr('src', image_sources[j]);
											});
									}
							}
					}
			},
		
		nrPagesPerCardChanged: function()
			{
				this.gallery_height = proportionsManager.screen_dimensions.h - 16;
				this.card_width = proportionsManager.image_modes.Diapo.w * cardManager.nr_pages_per_card + 16 * 2;
				this.nr_cards_per_row = parseInt(proportionsManager.screen_dimensions.w / this.card_width);
				this.nr_rows = parseInt(cardManager.nr_cards / this.nr_cards_per_row);
				
				if ((cardManager.nr_cards % this.nr_cards_per_row) > 0)
					{
						this.nr_rows += 1;
					}
				
				var another_row = ((this.gallery_height % this.card_height) > 0) ? 1 : 0;
				
				this.nr_cards_visible = this.nr_cards_per_row * (this.nr_cards_per_column + another_row);
			},
		
		calculateScrollXFromCardNumber: function(nr_card)
			{
				if (cardManager.nr_pages_per_card == 1)
					{
						var result = (nr_card - 1) * (proportionsManager.image_modes.Diapo.w + 8 * 2) - parseInt((proportionsManager.screen_dimensions.w - proportionsManager.image_modes.Diapo.w) / 2) + 8 + 8;
					}
				else if (cardManager.nr_pages_per_card == 2)
					{
						var result = nr_card * (proportionsManager.image_modes.Diapo.w * 2 + 8 * 2) - proportionsManager.image_modes.Diapo.w * 2 - parseInt(proportionsManager.screen_dimensions.w / 2);
					}
				
				return result;
			},
		
		calculateCardNumberFromScrollY: function(y_scroll)
			{
				var pos = y_scroll + parseInt(this.gallery_height / 2);
				var nr_rows_scrolled = parseInt(pos / this.card_height);
				
				if ((pos % this.card_height) >= parseInt(this.card_height / 2))
					{
						nr_rows_scrolled += 1;
					}
				
				var result = nr_rows_scrolled * this.nr_cards_per_row;
				
				return result;
			},
		
		scrollToCurrentCard: function()
			{
				var row_number = parseInt(cardManager.current_card_number / this.nr_cards_per_row);
				
				if ((cardManager.current_card_number % this.nr_cards_per_row) > 0)
					{
						row_number += 1;
					}
				
				var scroll_offset_y = row_number * this.card_height - parseInt(this.gallery_height / 2);
				
				var scroller = visualComponents.gallery.getScrollable().getScroller();
				
				if (scroll_offset_y < scroller.minPosition.y)
					{
						scroll_offset_y = scroller.minPosition.y;
					}
				else if (scroll_offset_y > scroller.maxPosition.y)
					{
						scroll_offset_y = scroller.maxPosition.y;
					}
				
				scroller.scrollTo(0, scroll_offset_y, false);
			}
	};