var linkHandler =
	{
		handleInternal: function(placeholder)
			{
				var params = placeholder.params;
				placeholder = Ext.get(placeholder[0]);
				
				placeholder.addListener(
					{
						singletap: function(e)
							{
								e.preventDefault();
								e.stopPropagation();
								
								setTimeout(function()
									{
										cardManager.changeCard(cardManager.getCardNumberFromPageIndex(params.url));
									},
									300
								);
								
								return false;
							},
						touchstart: function(e)
							{
								e.preventDefault();
							}
					});
			},
		
		handleExternal: function(placeholder)
			{
				var params = placeholder.params;
				
				placeholder.attr('href', params.url);
				placeholder.attr('target', params.target);
				
				placeholder = Ext.get(placeholder[0]);
			},
		
		handleLightbox: function(placeholder)
			{
				var params = placeholder.params;
				
				placeholder.attr('href', params.url);
				placeholder.attr('target', params.target);
				
				placeholder = Ext.get(placeholder[0]);
			},
		
		handleImage: function(placeholder)
			{
				var params = placeholder.params;
				
				var style = 'width: ' + parseInt(params.w * params.scale) + 'px; ' +
										'height: ' + parseInt(params.h * params.scale) + 'px;';
				
				var image = $('<img src="' + params.url + '" style="' + style + '" />');
				
				placeholder.append(image);
			},
		
		handleVideo: function(placeholder)
			{
				var params = placeholder.params;
				placeholder = Ext.get(placeholder[0]);
				
				if (params.target == 'swf_fiche')
					{
						placeholder.addListener({
							singletap: function(e)
								{
									setTimeout(function()
										{
											$('#popup_video').attr('src', params.url);
											componentsManager.showVideoPanel();
										},
										300
									);
									
									e.preventDefault();
									e.stopPropagation();
									
									return false;
								}
						});
					}
				else
					{
						var id = placeholder.getId();
						var video_id = id + '_html5_video';
						
						var video_elem = $('<video id="' + video_id + '" src="' + params.url + '" width="100%" height="100%" style="width: 100%; height: 100%;" controls="controls" preload="auto"></video>');
						video_elem[0].is_playing = false;
						
						$('#' + id).append(video_elem);
						
						Ext.get(video_id).addListener('tap', function(e)
							{
								if (!this.dom.is_playing)
									{
										this.dom.play();
										this.dom.is_playing = true;
									}
								else
									{
										this.dom.pause();
										this.dom.is_playing = false;
									}
								
								e.preventDefault();
								e.stopPropagation();
								
								return false;
							});
					}
			},
		
		handleAudio: function(placeholder)
			{
				var params = placeholder.params;
				
				if (params.target == 'swf_fiche')
					{
						placeholder = Ext.get(placeholder[0]);
						
						placeholder.addListener({
							singletap: function(e)
								{
									setTimeout(function()
										{
											$('#popup_audio').attr('src', params.url);
											componentsManager.showAudioPanel();
										},
										300
									);
									
									e.preventDefault();
									e.stopPropagation();
									
									return false;
								}
						});
					}
				else
					{
						placeholder = Ext.get(placeholder[0]);
						
						placeholder.addListener({
							singletap: function(e)
								{
									setTimeout(function()
										{
											$('#popup_audio').attr('src', params.url);
											componentsManager.showAudioPanel();
										},
										300
									);
									
									e.preventDefault();
									e.stopPropagation();
									
									return false;
								}
						});
					}
			}
	};