var linkManager =
	{
		pages_links: {},
		
		parseLink: function(link)
			{
				var result = new Object();
				
				result.handler = 'Null';
				result.params = new Object();
				
				if (link.zoom)
					{
						if (link.zoom == 'true')
							{
								result.handler = 'Zoom';
								
								return result;
							}
					}
				
				if ((link.url != undefined) &&
						(link.url.indexOf('lightbox:') == 0))
					{
						result.handler = 'Lightbox';
						result.params.url = link.url.substr('lightbox:'.length);
						result.params.tag = 'a';
						result.params.target = link.target;
						
						return result;
					}
				
				if (link.target == 'product')
					{
						result.handler = 'Product';
						
						return result;
					}
				
				if (link.target == 'swf_fiche')
					{
						if (link.url.toString().match(/\.((flv|mp4|m4v)+)$/))
							{
								result.handler = 'Video';
								result.params.url = app.path + 'fiches/' + link.url.replace(/\.flv$/, '.m4v');
								result.params.tag = 'div';
								result.params.target = link.target;
							}
						else if (link.url.toString().match(/\.((mp3|m4a)+)$/))
							{
								result.handler = 'Audio';
								result.params.url = app.path + 'fiches/' + link.url;
								result.params.tag = 'div';
								result.params.target = link.target;
							}
						
						return result;
					}
				
				if (link.target == 'swf_video')
					{
						if (link.url.toString().match(/\.((flv|mp4|m4v)+)$/))
							{
								var url_new = link.url.replace(/\.flv$/, '.m4v');
								var url_is_ok = false;
								
								if (windowUrl.urlExists(app.path + 'multimedia/' + url_new))
									{
										var url_file = app.path + 'multimedia/' + url_new;
										
										url_is_ok = true;
									}
								else
									{
										var url_file = app.path + 'fiches/' + url_new;
										
										url_is_ok = windowUrl.urlExists(app.path + 'fiches/' + url_new);
									}
								
								result.handler = 'Video';
								result.params.url = url_file;
								result.params.tag = 'div';
								result.params.target = link.target;
								//result.params.cls = 'multimedia_play_' + (url_is_ok ? 'ok' : 'error');
							}
						else if (link.url.toString().match(/\.((jpg|png|bmp|jpeg|gif)+)$/))
							{
								if (windowUrl.urlExists(app.path + 'multimedia/' + link.url))
									{
										var url_file = app.path + 'multimedia/' + link.url;
									}
								else
									{
										var url_file = app.path + 'fiches/' + link.url;
									}
								
								result.handler = 'Image';
								result.params.url = url_file;
								result.params.tag = 'div';
							}
						else if (link.url.toString().match(/\.((swf)+)$/))
							{
								result.handler = 'Flash';
							}
						
						return result;
					}
				
				if (link.target == 'mp3_sound')
					{
						if (link.url.toString().match(/\.((mp3|m4a)+)$/))
							{
								if (windowUrl.urlExists(app.path + 'multimedia/' + link.url))
									{
										var url_file = app.path + 'multimedia/' + link.url;
									}
								else
									{
										var url_file = app.path + 'fiches/' + link.url;
									}
								
								result.handler = 'Audio';
								result.params.url = url_file;
								result.params.tag = 'div';
								result.params.target = link.target;
							}
						
						return result;
					}
				
				if (link.target == 'gallery_HD')
					{
						result.handler = 'GalleryHD';
						
						return result;
					}
				
				if ((link.url != undefined) &&
						(link.page == undefined))
					{
						result.handler = 'External';
						result.params.url = link.url;
						result.params.tag = 'a';
						result.params.target = link.target;
						
						return result;
					}
				
				if (link.page != undefined)
					{
						result.handler = 'Internal';
						result.params.url = link.page;
						result.params.tag = 'div';
						
						return result;
					}
				
				return result;
			},
		
		createElement: function(params)
			{
				var style = 'width: ' + params.w + 'px; ' +
										'height: ' + params.h + 'px; ' +
										'left: ' + params.left + 'px; ' +
										'top: ' + params.top + 'px;';
				
				var element = $('<' + params.tag + ' class="' + params.base_cls + params.cls + '" title="' + params.url + '" style="' + style + '"></' + params.tag + '>');
				params.parent.append(element);
				
				return element;
			},
		
		calculateTopOffset: function()
			{
				return proportionsManager.stage.top;
			},
		
		calculateLeftOffset: function(page_number)
			{
				return proportionsManager.stage.left[page_number % cardManager.nr_pages_per_card];
			},
		
		createLink: function(link, info, base_class, parent_element)
			{
				var element = this.createElement({
					tag: info.params.tag,
					base_cls: (base_class != null) ? base_class : '',
					cls: (info.params.cls != undefined) ? (' ' + info.params.cls) : '',
					url: info.params.url,
					w: parseInt(link.w * link.scale),
					h: parseInt(link.h * link.scale),
					left: parseInt(link.x * link.scale + link.left),
					top: parseInt(link.y * link.scale + link.top),
					parent: parent_element
				});
				
				info.params.base_cls = base_class;
				info.params.scale = link.scale;
				info.params.w = link.w;
				info.params.h = link.h;
				
				element.params = info.params;
				
				linkHandler['handle' + info.handler](element);
			},
		
		displayPageLinks: function(page_number, parent_element, base_class, link_scale)
			{
				var links = this.pages_links['page-' + page_number];
				
				if (links != undefined)
					{
						var offset_left = this.calculateLeftOffset(page_number);
						var offset_top = this.calculateTopOffset();
						
						for (var i = 0; i < links.length; i++)
							{
								var link = links[i];
								
								link.left = offset_left;
								link.top = offset_top;
								link.scale = link_scale;
								
								var info = this.parseLink(link);
								
								if (linkHandler.hasOwnProperty('handle' + info.handler))
									{
										this.createLink(link, info, base_class, parent_element);
									}
							}
					}
			},
		
		displayCurrentCardLinks: function()
			{
				this.removeAllLinks();
				
				var pages_numbers = cardManager.getPagesNumbersFromCardNumber(cardManager.current_card_number);
				
				for (var i = 0; i < pages_numbers.length; i++)
					{
						this.displayPageLinks(pages_numbers[i], $('#sub-page-' + cardManager.current_card_number), 'link_page', proportionsManager.stage.link_scale);
						this.displayPageLinks(pages_numbers[i], $('#zoom_container_scaled'), 'link_zoom', proportionsManager.stage.link_scale);
					}
			},
		
		removeAllLinks: function()
			{
				$('.link_page').remove();
				$('.link_zoom').remove();
			}
	};