var proportionsManager =
	{
		orientation: null,
		
		screen_dimensions:
			{
				w: null,
				h: null
			},
		
		view_dimensions:
			{
				w: null,
				h: null
			},
		
		axis:
			{
				main: 'w',
				aux: 'h'
			},
		
		stage:
			{
				w: null,
				h: null,
				top: null,
				left: [],
				link_scale: null,
				zoom_scale: null
			},
		
		image_modes:
			{
				'Diapo': {w: 0, h: 0},
				'Small': {w: 0, h: 0},
				'Big': {w: 0, h: 0},
				'Big1': {w: 0, h: 0},
				'Big2': {w: 0, h: 0},
				'Zoom': {w: 0, h: 0}
			},
		
		ratio_min:
			{
				wh: 10000,
				hw: 10000
			},
		
		_array_image_modes: [],
		
		current_image_mode: null,
		
		updateOrientation: function()
			{
				this.orientation = (window.innerWidth < window.innerHeight) ? 'portrait' : 'landscape';
			},
		
		calculateDimensions: function()
			{
				this.updateOrientation();
				
				var orientation_complementary = (this.orientation == 'portrait') ? 'landscape' : 'portrait';
				
				$('body').removeClass(orientation_complementary)
								 .addClass(this.orientation);
				
				this.screen_dimensions.w = window.innerWidth;
				this.screen_dimensions.h = window.innerHeight;
				
				zoomManager.slide_overflow.w = parseInt(proportionsManager.screen_dimensions.w / 4);
				zoomManager.slide_overflow.h = parseInt(proportionsManager.screen_dimensions.h / 4);
				
				$('#styles_dynamic').empty();
				
				$('#styles_dynamic').append('.' + this.orientation + '_w {width: ' + this.screen_dimensions.w + 'px !important;}');
				$('#styles_dynamic').append('.' + this.orientation + '_h {height: ' + this.screen_dimensions.h + 'px !important;}');
			},
		
		calculateView: function()
			{
				this.view_dimensions.w = this.screen_dimensions.w / cardManager.nr_pages_per_card;
				this.view_dimensions.h = this.screen_dimensions.h;
				
				this.determineCurrentImageMode();
				
				carouselThumbnailsManager.nrPagesPerCardChanged();
				galleryManager.nrPagesPerCardChanged();
			},
		
		setImageMode: function(mode, w, h)
			{
				this.image_modes[mode].w = parseInt(w);
				this.image_modes[mode].h = parseInt(h);
				
				var ratio_wh = this.image_modes[mode].w / this.image_modes[mode].h;
				var ratio_hw = this.image_modes[mode].h / this.image_modes[mode].w;
				
				if (ratio_wh < this.ratio_min.wh)
					{
						this.ratio_min.wh = ratio_wh;
					}
				
				if (ratio_hw < this.ratio_min.hw)
					{
						this.ratio_min.hw = ratio_hw;
					}
			},
		
		sortImageModes: function()
			{
				for (var i in this.image_modes)
					{
						this._array_image_modes.push({
							name: i,
							w: this.image_modes[i].w,
							h: this.image_modes[i].h
						});
					}
				
				if (this.image_modes.Diapo.w > this.image_modes.Diapo.h)
					{
						this._array_image_modes.sort(function(a, b)
							{
								return a.w - b.w;
							});
					}
				else
					{
						this._array_image_modes.sort(function(a, b)
							{
								return a.h - b.h;
							});
					}
			},
		
		determineCurrentImageMode: function()
			{
				if (this.view_dimensions.w <= this.view_dimensions.h)
					{
						this.axis.main = 'h';
						this.axis.aux = 'w';
					}
				
				var ratio_view = this.view_dimensions[this.axis.main] / this.view_dimensions[this.axis.aux];
				var ratio_img = this.ratio_min[this.axis.main + this.axis.aux];
				
				if (ratio_img < ratio_view)
					{
						var temp = this.axis.main;
						this.axis.main = this.axis.aux;
						this.axis.aux = temp;
					}
				
				for (var i = 0; i < this._array_image_modes.length; i++)
					{
						if (this._array_image_modes[i][this.axis.main] >= this.view_dimensions[this.axis.main])
							{
								this.current_image_mode = this._array_image_modes[i].name;
								
								break;
							}
					}
				
				this.calculateStage();
			},
		
		calculateStage: function()
			{
				var ratio = this.image_modes[this.current_image_mode][this.axis.main] / this.view_dimensions[this.axis.main];
				
				this.stage[this.axis.main] = this.view_dimensions[this.axis.main];
				this.stage[this.axis.aux] = parseInt(this.image_modes[this.current_image_mode][this.axis.aux] / ratio);
				this.stage.top = parseInt((this.view_dimensions.h - this.stage.h) / 2);
				this.stage.left = new Array(cardManager.nr_pages_per_card);
				
				if (cardManager.nr_pages_per_card == 1)
					{
						this.stage.left[0] = parseInt((this.view_dimensions.w - this.stage.w) / 2);
					}
				else
					{
						this.stage.left[0] = this.view_dimensions.w - this.stage.w;
						this.stage.left[1] = this.view_dimensions.w;
					}
				
				this.stage.link_scale = this.stage.h / this.image_modes.Big.h;
				this.stage.zoom_scale = this.stage.h / this.image_modes.Zoom.h;
				
				zoomManager.offset_left.unzoomed = parseInt((this.view_dimensions.w - this.stage.w) * cardManager.nr_pages_per_card / 2);
				zoomManager.offset_top.unzoomed = parseInt((this.view_dimensions.h - this.stage.h) / 2);
				
				var b = 'body.' + this.orientation + ' ';
				
				$('#styles_dynamic').append(b + '.x-mask {width: ' + this.screen_dimensions.w + 'px !important; height: ' + this.screen_dimensions.h + 'px !important;}');
				$('#styles_dynamic').append(b + '.page, ' + b + '.sub-page {width: ' + this.screen_dimensions.w + 'px; height: ' + this.screen_dimensions.h + 'px;}');
				$('#styles_dynamic').append(b + '.sub-page .page-img {width: ' + this.stage.w + 'px; height: ' + this.stage.h + 'px; top: ' + this.stage.top + 'px;}');
				$('#styles_dynamic').append(b + '.sub-page .page-img:nth-of-type(1) {left: ' + this.stage.left[0] + 'px;}');
				$('#styles_dynamic').append(b + '.sub-page .page-img:nth-of-type(2n) {' + ((cardManager.nr_pages_per_card == 1) ? 'display: none;' : 'left: ' + this.stage.left[1] + 'px;') + '}');
				$('#styles_dynamic').append(b + '.img_zoom {width: ' + this.stage.w + 'px; height: ' + this.stage.h + 'px; top: ' + this.stage.top + 'px;}');
				$('#styles_dynamic').append(b + '.img_zoom:nth-of-type(1) {left: ' + parseInt(((this.view_dimensions.w - this.stage.w) * cardManager.nr_pages_per_card) / 2) + 'px;}');
				$('#styles_dynamic').append(b + '.img_zoom:nth-of-type(2n) {' + ((cardManager.nr_pages_per_card == 1) ? 'display: none;' : 'left: ' + this.view_dimensions.w + 'px;') + '}');
			},
		
		getCurrentImageModeWidth: function()
			{
				return this.image_modes[this.current_image_mode].w;
			},
		
		getCurrentImageModeHeight: function()
			{
				return this.image_modes[this.current_image_mode].h;
			},
	};