var searchManager =
	{
		texts: null,
		text_to_find: null,
		search_results: [],
		search_panel_outer_width: 322,
		search_panel_inner_width: 286,
		max_content_length: 120,
		max_chars_before_result: 20,
		
		attachEvents: function()
			{
				Ext.get('close_search_panel').addListener('singletap', function()
					{
						componentsManager.hideSearchPanel();
					});
				
				Ext.get('search_text').addListener('singletap', function()
					{
						searchManager.findText($('#input_text_search').attr('value'));
					});
				
				Ext.get('input_text_search').addListener('keydown', function(e)
					{
						if (e.event.keyCode == 13)
							{
								searchManager.findText($(this).attr('value'));
							}
					});
				
				Ext.get('form_search').addListener('submit', function(e)
					{
						e.preventDefault();
						
						return false;
					});
			},
		
		findText: function(text)
			{
				$('#input_text_search').blur();
				
				if (text != undefined)
					{
						searchManager.text_to_find = $.trim(text);
					}
				
				if (searchManager.texts == null)
					{
						ajaxManager.getTexts();
					}
				else
					{
						searchManager.search_results = [];
						visualComponents.search_results_panel.removeAll();
						
						if (searchManager.text_to_find.length > 0)
							{
								for (var i = 0; i < searchManager.texts.length; i++)
									{
										var index = searchManager.texts[i].content.indexOf(searchManager.text_to_find);
										
										if (index > -1)
											{
												var page_number = searchManager.texts[i].page_number;
												
												searchManager.search_results.push({
													page_number: page_number,
													first_index: index,
													last_index: searchManager.texts[i].content.lastIndexOf(searchManager.text_to_find)
												});
												
												var content = searchManager.texts[i].content.replace(/\s/g, ' ');
												
												if (content.length > this.max_content_length)
													{
														var prefix = '';
														var suffix = '';
														var index_start = index - this.max_chars_before_result;
														
														if (index_start < 0)
															{
																index_start = 0;
															}
														else
															{
																prefix = '...';
																index_start = index - this.max_chars_before_result + prefix.length;
															}
														
														var offset_stop = index_start + this.max_content_length;
														
														if (content.length > offset_stop)
															{
																suffix = '...';
															}
														
														content = prefix + content.substr(index_start, this.max_content_length - (prefix.length + suffix.length)) + suffix;
													}
												
												var html_content = '<div style="width: ' + this.search_panel_inner_width + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px;">' +
																						 '<div style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px; float: left; display: inline;">' +
																							 '<img src="' + app.path + 'Diapo/page' + page_number + '.jpg' + '" style="width: ' + proportionsManager.image_modes.Diapo.w + 'px; height: ' + proportionsManager.image_modes.Diapo.h + 'px;" />' +
																						 '</div>' +
																						 
																						 '<div style="width: ' + (this.search_panel_inner_width - proportionsManager.image_modes.Diapo.w - 8) + 'px; float: right; display: inline; color: #000000; text-align: left;">' +
																							 '<div style="height: 17px; padding-right: 8px; font-size: 14px; font-weight: bold;">' +
																							 	 translatorEngine.indexes.idx_93.charAt(0).toUpperCase() + translatorEngine.indexes.idx_93.slice(1) + ' ' + page_number +
																						 	 '</div>' +
																						 	 
																						 	 '<div style="height: ' + (proportionsManager.image_modes.Diapo.h - 17) + 'px; padding-top: 8px; font-size: 12px;">' +
																						 	 	  content +
																						 	 '</div>' +
																						 '</div>' +
																					 '</div>';
												
												visualComponents.search_results_panel.add(Ext.create('Ext.Panel', {
													id: 'search_result_' + page_number,
													cls: 'search_result',
													width: this.search_panel_inner_width,
													height: proportionsManager.image_modes.Diapo.h,
													style: (searchManager.search_results.length > 1) ? 'margin-top: 12px;' : '',
													
													layout:
														{
															align: 'start',
															pack: 'start'
														},
													
													html: html_content
												}));
											}
									}
							}
						
						searchManager.resizeSearchPanel();
					}
			},
		
		resizeSearchPanel: function()
			{
				if (searchManager.search_results.length > 0)
					{
						var search_panel_height_max = parseInt(proportionsManager.screen_dimensions.h * 0.75);
						search_panel_height_max = (proportionsManager.screen_dimensions.h > 380) ? search_panel_height_max : proportionsManager.screen_dimensions.h;
						
						var results_height = searchManager.search_results.length * (proportionsManager.image_modes.Diapo.h + 12) + $('#form_search_controls').height() + 12 * 2 + 1;
						var search_panel_height = (search_panel_height_max <= results_height) ? search_panel_height_max : results_height;
						
						visualComponents.search_panel.setHeight(search_panel_height);
						visualComponents.search_results_panel.setHeight(search_panel_height - $('#form_search_controls').height() - 12 * 3 - 6);
						
						$('.search_result').each(function()
							{
								var el = Ext.get($(this).attr('id'));
								var id = $(this).attr('id').substr('search_result_'.length);
								
								el.removeListener('singletap');
								
								el.addListener('singletap', function()
									{
										componentsManager.hideSearchPanel();
										
										cardManager.changeCard(cardManager.getCardNumberFromPageIndex(id));
									});
							});
					}
				else
					{
						if (visualComponents.search_results_panel)
							{
								var search_panel_height = 88;
								
								visualComponents.search_panel.setHeight(search_panel_height);
								visualComponents.search_results_panel.setHeight(search_panel_height - $('#form_search_controls').height() - 12 * 3 - 6);
								
								visualComponents.search_results_panel.add(Ext.create('Ext.Panel', {
									style: 'height: 14px; font-size: 13px; color: #000000; text-align: center;',
									
									layout:
										{
											align: 'start',
											pack: 'start'
										},
									
									html: translatorEngine.indexes.idx_36
								}));
							}
					}
				
				$('#search_results').removeClass('invisible');
			}
	};