var stringUtils =
	{
		isBlankString: function(str)
			{
				if ((str === undefined) ||
						(str === null) ||
						(str === false) ||
						(str === ''))
					{
						return true;
					}
				
				return false;
			},
		
		isUrl: function(str)
			{
				var regexp = /^(http|https|ftp):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
				
				return regexp.test(str);
			},
		
		prependPads: function(string, str_len, pad_str)
			{
				var result = string;
				
				if (string.length < str_len)
					{
						var nr_pads = str_len - string.length;
						var pad = '';
						
						for (var i = 1; i <= nr_pads; i++)
							{
								pad += pad_str;
							}
						
						result = pad + string;
					}
				
				return result;
			},
		
		hexToHtml: function(hexa)
			{
				return hexa.replace('0x', '#');
			},
		
		hexToRGB: function(hexa)
			{
				hexa = hexa.replace('#', '');
				
				return {r: parseInt(hexa.substring(0, 2), 16),
								g: parseInt(hexa.substring(2, 4), 16),
								b: parseInt(hexa.substring(4, 6), 16)};
			},
		
		stringToXML: function(text)
			{
				if (window.ActiveXObject)
					{
						var doc = new ActiveXObject('Microsoft.XMLDOM');
						
						doc.async = 'false';
						doc.loadXML(text);
					}
				else
					{
						var parser = new DOMParser();
						var doc = parser.parseFromString(text, 'text/xml');
					}
				
				return doc;
			}
	};