var topBarManager =
	{
		height: 42,
		xml: null,
		special_icon_width: null,
		special_icons_hidden: 0,
		
		load_status_special_icons: 
			{
				summary: false,
				gallery: false,
				mail: false,
				showreel: false,
				search: false
			},
		
		load_status_containers: 
			{
				left: 1,
				middle: 1,
				right: 1
			},
		
		icon_containers_widths:
			{
				left: 0,
				middle: 0,
				right: 0
			},
		
		loadLogo: function()
			{
				if (!Globals.is_Phone &&
						(this.xml.find('[type="logo"]').length == 1))
					{
						imagesManager.preloadImage(app.path + imagesManager.logo, topBarManager.evtOnLoadLogo, topBarManager.evtOnErrorLogo);
					}
				else
					{
						topBarManager.loadCustomButtons('left');
					}
			},
		
		loadSpecialIcons: function()
			{
				if ((summaryManager.items.length > 0) &&
						(this.xml.find('[type="sommaire"]').length == 1))
					{
						componentsManager.createIconSummary();
					}
				else
					{
						this.load_status_special_icons.summary = true;
					}
				
				if (this.xml.find('[type="vignette"]').length == 1)
					{
						componentsManager.createIconGallery();
					}
				else
					{
						this.load_status_special_icons.gallery = true;
					}
				
				if (this.xml.find('[type="mail"]').length == 1)
					{
						componentsManager.createIconMail();
					}
				else
					{
						this.load_status_special_icons.mail = true;
					}
				
				if (!Globals.is_Phone)
					{
						componentsManager.createIconShowreel();
					}
				else
					{
						this.load_status_special_icons.showreel = true;
					}
				
				componentsManager.createIconSearch();
				
				this.checkLoadStatusSpecialIcons();
			},
		
		evtOnLoadLogo: function(e)
			{
				if (e.target.onerror != null)
					{
						if (app.params.logoMenuURL.value != '')
							{
								var html_content = '<a href="' + app.params.logoMenuURL.value + '" id="top_bar_logo">' +
																		 '<img src="' + e.target.src + '" style="height: ' + topBarManager.height + 'px;" />' +
																	 '</a>';
							}
						else
							{
								var html_content = '<div id="top_bar_logo">' +
																		 '<img src="' + e.target.src + '" style="height: ' + topBarManager.height + 'px;" />' +
																	 '</div>';
							}
						
						$('#container_custom_buttons_LEFT').append(html_content);
						
						Ext.get('top_bar_logo').addListener('singletap', function(e)
							{
								e.stopPropagation();
								
								if (this.getAttribute('href') == undefined)
									{
										cardManager.changeCard(1);
									}
								else
									{
										return true;
									}
							});
						
						var ratio = e.target.height / topBarManager.height;
						
						topBarManager.icon_containers_widths.left += parseInt(e.target.width / ratio);
					}
				
				topBarManager.loadCustomButtons('left');
			},
		
		evtOnErrorLogo: function(e)
			{
				e.target.onerror = null;
				
				e.target.onload(e);
				
				return true;
			},
		
		createSpecialIconStyles: function(img_obj, icon_class)
			{
				var canvas_icons = document.getElementById('canvas_icons');
				var context_icons = canvas_icons.getContext('2d');
				
				context_icons.clearRect(0, 0, canvas_icons.width, canvas_icons.height);
				context_icons.drawImage(img_obj, 0, 0);
				
				if (Ext.os.is.Android && Ext.os.version.lt(3))
					{
						$('#styles_fixed').append('#special_icons_panel img.' + icon_class + ' {background: transparent !important;}');
					}
				else
					{
						$('#styles_fixed').append('#special_icons_panel img.' + icon_class + ' {-webkit-mask-box-image: url(' + canvas_icons.toDataURL() + '); background: ' + app.color_foreground + ' !important;}');
					}
				
				var canvas_contours = document.getElementById('canvas_contours');
				var context_contours = canvas_contours.getContext('2d');
				
				context_contours.clearRect(0, 0, canvas_contours.width, canvas_contours.height);
				
				var color_aux = stringUtils.hexToRGB(app.color_foreground);
				var color_style = 'rgba(' + (255 - parseInt(color_aux.r)) + ', ' + (255 - parseInt(color_aux.g)) + ', ' + (255 - parseInt(color_aux.b)) + ', ' + imagesManager.special_icons_alpha + ')';
				
				context_contours.shadowOffsetX = 0;
				context_contours.shadowOffsetY = 0;
				context_contours.shadowBlur = 12;
				context_contours.shadowColor = color_style;
				context_contours.stroke();
				
				context_contours.drawImage(img_obj, 0, 0);
				
				if (Ext.os.is.Android && Ext.os.version.lt(3))
					{
						$('#styles_fixed').append('#special_contours_panel img.' + icon_class + ' {background: transparent !important;}');
					}
				else
					{
						$('#styles_fixed').append('#special_contours_panel img.' + icon_class + ' {-webkit-mask-box-image: url(' + canvas_contours.toDataURL() + '); background: ' + color_style + ' !important;}');
					}
			},
		
		evtOnLoadSpecialIconHidden: function(e)
			{
				if (e.target.onerror != null)
					{
						var img_obj = e.target;
						var icon_class = (img_obj.params_aux.icon_class == undefined) ? img_obj.params_aux.name : img_obj.params_aux.icon_class;
						
						topBarManager.createSpecialIconStyles(img_obj, icon_class);
					}
			},
		
		evtOnErrorSpecialIconHidden: function(e)
			{
				e.target.onerror = null;
				
				e.target.onload(e);
				
				return true;
			},
		
		evtOnLoadSpecialIcon: function(e)
			{
				var img_obj = e.target;
				
				if (e.target.onerror != null)
					{
						var icon_class = (img_obj.params_aux.icon_class == undefined) ? img_obj.params_aux.name : img_obj.params_aux.icon_class;
						
						topBarManager.createSpecialIconStyles(img_obj, icon_class);
						
						if (topBarManager.special_icon_width == null)
							{
								var ratio = img_obj.height / topBarManager.height;
								
								topBarManager.special_icon_width = parseInt(img_obj.width / ratio) + 16;
							}
						
						topBarManager.icon_containers_widths.middle += topBarManager.special_icon_width;
					}
				
				topBarManager.load_status_special_icons[img_obj.params_aux.name] = true;
				
				topBarManager.checkLoadStatusSpecialIcons();
			},
		
		evtOnErrorSpecialIcon: function(e)
			{
				e.target.onerror = null;
				
				e.target.onload(e);
				
				return true;
			},
		
		evtOnLoadCustomIconTopBar: function(e)
			{
				if (!e.target.params_aux.hasOwnProperty('error'))
					{
						var html_content = '<a href="' + e.target.params_aux.url + '" target="' + e.target.params_aux.target + '" class="top_bar_custom_button">' +
																 '<img src="' + e.target.src + '" />' +
															 '</a>';
						
						$('#container_custom_buttons_' + e.target.params_aux.position.toUpperCase()).append(html_content);
						
						var ratio = e.target.height / topBarManager.height;
						
						topBarManager.icon_containers_widths[e.target.params_aux.position] += parseInt(e.target.width / ratio) + 16;
					}
				
				topBarManager.load_status_containers[e.target.params_aux.position] -= 1;
				
				if (topBarManager.load_status_containers[e.target.params_aux.position] == 0)
					{
						topBarManager.checkLoadStatusContainers();
					}
			},
		
		evtOnErrorCustomIconTopBar: function(e)
			{
				e.target.params_aux.error = true;
				
				e.target.onload(e);
				
				return true;
			},
		
		evtOnLoadDiapo: function(e)
			{
				if (e.target.onerror != null)
					{
						proportionsManager.setImageMode('Diapo', e.target.width, e.target.height);
						
						galleryManager.card_height = proportionsManager.image_modes.Diapo.h + 23 + 16 * 2;
						galleryManager.nr_cards_per_column = parseInt((proportionsManager.screen_dimensions.h - 16) / galleryManager.card_height);
					}
				
				ajaxManager.getTranslations();
			},
		
		evtOnErrorDiapo: function(e)
			{
				e.target.onerror = null;
				
				e.target.onload(e);
				
				return true;
			},
		
		checkLoadStatusContainers: function()
			{
				var everything_is_loaded = true;
				
				for (var i in topBarManager.load_status_containers)
					{
						if (topBarManager.load_status_containers[i] > 0)
							{
								everything_is_loaded = false;
								
								break;
							}
					}
			},
		
		checkLoadStatusSpecialIcons: function()
			{
				var everything_is_loaded = true;
				
				for (var i in topBarManager.load_status_special_icons)
					{
						if (topBarManager.load_status_special_icons[i] == false)
							{
								everything_is_loaded = false;
								
								break;
							}
					}
				
				if (everything_is_loaded)
					{
						componentsManager.createSpecialIconsPanels();
						
						if (visualComponents.icon_summary != null)
							{
								visualComponents.special_icons_panel.add(visualComponents.icon_summary);
								visualComponents.special_contours_panel.add(visualComponents.contour_summary);
							}
						
						if (visualComponents.icon_gallery != null)
							{
								visualComponents.special_icons_panel.add(visualComponents.icon_gallery);
								visualComponents.special_contours_panel.add(visualComponents.contour_gallery);
							}
						
						if (visualComponents.icon_mail != null)
							{
								visualComponents.special_icons_panel.add(visualComponents.icon_mail);
								visualComponents.special_contours_panel.add(visualComponents.contour_mail);
							}
						
						if (visualComponents.icon_showreel != null)
							{
								visualComponents.special_icons_panel.add(visualComponents.icon_showreel);
								visualComponents.special_contours_panel.add(visualComponents.contour_showreel);
							}
						
						if (visualComponents.icon_search != null)
							{
								visualComponents.special_icons_panel.add(visualComponents.icon_search);
								visualComponents.special_contours_panel.add(visualComponents.contour_search);
							}
						
						visualComponents.special_icons_panel.setWidth(topBarManager.icon_containers_widths.middle);
						visualComponents.special_icons_panel.show();
						
						visualComponents.special_contours_panel.setWidth(topBarManager.icon_containers_widths.middle);
						visualComponents.special_contours_panel.show();
						
						topBarManager.loadCustomButtons('middle');
					}
			},
		
		loadCustomButtons: function(position_en)
			{
				var position_fr = (position_en == 'left')
														? 'gauche'
														: ((position_en == 'middle') 
																? 'milieu'
																: ((position_en == 'right')
																		? 'droite'
																		: null));
				
				var custom_buttons_to_load = [];
				var custom_buttons = topBarManager.xml.find(position_fr).children('bouton[type="custom"]');
				
				for (var i = 0; i < custom_buttons.length; i++)
					{
						if (custom_buttons[i].hasAttribute('url') &&
								stringUtils.isUrl(custom_buttons[i].getAttribute('url')))
							{
								var custom_button = {};
								
								custom_button.position = position_en;
								custom_button.url = custom_buttons[i].getAttribute('url');
								custom_button.target = (custom_buttons[i].hasAttribute('target') && (custom_buttons[i].getAttribute('target') == '_self'))
																				 ? '_self'
																				 : '_blank';
								custom_button.icon_path = custom_buttons[i].getAttribute('classe');
								
								if (!stringUtils.isUrl(custom_button.icon_path))
									{
										custom_button.icon_path = app.path + custom_button.icon_path;
									}
								
								custom_buttons_to_load.push(custom_button);
							}
					}
				
				topBarManager.load_status_containers[position_en] = custom_buttons_to_load.length;
				
				if (topBarManager.load_status_containers[position_en] == 0)
					{
						topBarManager.checkLoadStatusContainers();
					}
				else
					{
						for (var i = 0; i < custom_buttons_to_load.length; i++)
							{
								imagesManager.preloadImage(custom_buttons_to_load[i].icon_path,
																					 topBarManager.evtOnLoadCustomIconTopBar,
																					 topBarManager.evtOnErrorCustomIconTopBar,
																					 custom_buttons_to_load[i]);
							}
					}
			}
	};