var windowUrl =
	{
		location: null,
		query_string: {},
		hashes: {
			page: '',
			state: ''
		},
		
		parse: function(href)
			{
				var href_parts = href.split('?');
				
				this.location = href_parts[0];
				
				if (href_parts.length >= 2)
					{
						var hash_pos = href_parts[1].indexOf('#');
						hash_pos = (hash_pos >= 0) ? hash_pos : href.length;
						
						var params = href_parts[1].substr(0, hash_pos).split('&');
						
						for (var i in params)
							{
								var param = params[i];
								
								if (typeof(param) == 'string')
									{
										var tmp = param.split('=');
										
										this.query_string[tmp[0]] = decodeURI(tmp[1]);
									}
							}
					}
				
				var lng = this.getQueryString('lng');
				
				if ((lng == undefined) || (lng.length == 0))
					{
						this.query_string.lng = 'fr';
					}
				
				this.fillHashes(window.location.hash);
				
				var start_page = this.getQueryString('startPage');
				
				if ((start_page != undefined) &&
						(start_page.length > 0))
					{
						this.hashes.page = start_page;
					}
				
				cardManager.start_page = this.hashes.page;
				cardManager.current_card_number = cardManager.getCardNumberFromPageIndex(this.hashes.page);
			},
		
		fillHashes: function(current_hash)
			{
				var current_hashes = current_hash.replace('#', '').split('_');
				var counter = 0;
				
				for (var i in this.hashes)
					{
						if ((current_hashes.length - 1) < counter)
							{
								this.hashes[i] = '';
							}
						else
							{
								this.hashes[i] = current_hashes[counter];
							}
						
						counter += 1;
					}
				
				this.hashes.page = parseInt(this.hashes.page);
				this.hashes.page = (stringUtils.isBlankString(this.hashes.page) || isNaN(this.hashes.page)) ? 1 : this.hashes.page;
			},
		
		executeHashes: function()
			{
				cardManager.changeCard(cardManager.getCardNumberFromPageIndex(this.hashes.page));
				
				if (this.hashes.state == 'gallery')
					{
						componentsManager.showGallery();
					}
				else if (this.hashes.state == 'summary')
					{
						componentsManager.showSummary();
					}
				else if (this.hashes.state == 'search')
					{
						componentsManager.showSearchPanel();
					}
				else if (this.hashes.state == 'share')
					{
						componentsManager.showShareWithFriend();
					}
				else if (this.hashes.state == 'zoom')
					{
						zoomManager.zoomElement();
					}
				else
					{
						componentsManager.hideGallery();
						componentsManager.hideSummary();
						componentsManager.hideSearchPanel();
						componentsManager.hideShareWithFriend();
						
						if (zoomManager.is_zoomed)
							{
								zoomManager.unZoomElement(false);
							}
					}
				
				Globals.back_pressed = true;
			},
		
		getQueryString: function(key)
			{
				return this.query_string[key];
			},
		
		buildShareUrl: function()
			{
				var result = this.location;
				
				var queries = [];
				
				for (var i in this.query_string)
					{
						if (i != 'startPage')
							{
								queries.push(i + '=' + this.query_string[i]);
							}
					}
				
				queries.push('startPage=' + cardManager.start_page);
				
				result += '?' + queries.join('&');
				
				return result;
			},
		
		urlExists: function(url)
			{
				var http = new XMLHttpRequest();
				
				http.open('HEAD', url, false);
				http.send();
				
				return (http.status != 404) ? true : false;
			},
		
		changeHash: function(hash, value)
			{
				Globals.back_pressed = false;
				
				value = stringUtils.isBlankString(value) ? '' : value.toString();
				this.hashes[hash] = value;
				
				var hash_tokens = [];
				
				for (var i in this.hashes)
					{
						hash_tokens.push(this.hashes[i]);
					}
				
				window.location.hash = hash_tokens.join('_');
			},
		
		hashChanged: function(current_hash)
			{
				this.fillHashes(current_hash);
				this.executeHashes();
			}
	};