var Zoom = function(element, options)
	{
		this.options = Ext.applyIf(options, this.options);
		
		this.element = document.createElement('div');
		
		var self = this;
		
		this.transScale = this.options.transScale;
		this.minZoom = this.options.minZoom * this.transScale;
		this.maxZoom = this.options.maxZoom * this.transScale;
	}

Zoom.prototype = {
	options: {
		minZoom: 2,
		maxZoom: 3,
		onMinZoom: function(){},
		onMaxZoom: function(){},
		onUnZoom: function(){},
		onZoomStart: function(){},
		onZoomReady: function(){},
		zoomWidth: 0,
		zoomHeight: 0,
		transScale: 1,
		springLength: 40
	},
	
	init: function(e)
		{
			this.options.onZoomStart();
			var self = this;
			
			this.imgHolder = document.createElement('div');
			this.imgHolder.style.height = proportionsManager.getHeight() + 'px';
			
			document.body.appendChild(this.imgHolder);
			this.imgHolder.id = 'zoomHolder-' + Math.random();
			
			this.imgHolder.className = 'zoomHolder';// x-' + Ext.getOrientation();
			this.imgHolder.appendChild(this.element);
			
			this.element.addEventListener('touchMove', function(e)
				{
					e.preventDefault();
					return false;
				});
			
			this.element.addEventListener('touchMove', function(e)
				{
					e.preventDefault();
					return false;
				});
			
			this.element.id = 'content-container';
			this.element.style.height = this.options.zoomHeight + 'px';
			
			this.images = document.querySelectorAll('#tmp img');
			
			var pg = visualComponents.carousel_default.getActiveItem().el.dom;
			var baseImg = pg.querySelectorAll('.page-img[src$=jpg]');
			
			var len = baseImg.length;
			var zoom_margin = 0;
			
			if ((Ext.getOrientation() == 'landscape') &&
					(this.options.index == 0))
				{
					len = 2;
					zoom_margin = this.options.zoomWidth;
				}
			
			this.element.style.width = this.options.zoomWidth * len + 'px';
			
			var linkFactor = this.options.zoomHeight / this.options.linkHeight;
			
			this.imgLength = baseImg.length;
			
			for (var i = 0; i < this.imgLength; i++)
				{
					var img = this.images[i];
					this.element.appendChild(img);
					img.style.width = this.options.zoomWidth + 'px';
					img.style.height = this.options.zoomHeight + 'px';
					img.src = baseImg[i].src;//.replace(/Small|Big1|Big2|Big|Diapo/, 'Diapo');
					
					if (zoom_margin > 0)
						{
							img.style.webkitTransform = 'translate(' + zoom_margin + 'px, 0px)';
						}
					
					var page_index = /\/page([0-9]+)\.jpg/.exec(img.src)[1];
					
					linkManager.displayPageLinks(
						page_index,
						Ext.get(this.element),
						linkFactor,
						{
							left: i * this.options.zoomWidth,
							margin: (zoom_margin > 0) ? zoom_margin : 0
						}
					);
				}
			
			this.baseScrollLeft = baseImg[0].offsetLeft / this.transScale;
			this.baseScrollTop = baseImg[0].offsetTop / this.transScale;
			
			this.element.style.webkitTransform = 'scale(' + this.transScale + ') translate3d(' + this.baseScrollLeft + 'px, ' + this.baseScrollTop + 'px, 0px)';
			
			for (var i = 0; i < this.imgLength; i++)
				{
					new Ext.util.DelayedTask(function(img)
						{
							img.src = img.src.replace(/Small|Big1|Big2|Big|Diapo/, Ext.is.Phone ? 'Big2' : 'Zoom');
						}, this, [this.images[i]]).delay(710);
				}
			
			setTimeout(function()
				{
					var scrollLeft = ((((self.element.offsetWidth - self.baseScrollLeft) * self.minZoom) - (self.element.offsetWidth * self.transScale)) / self.minZoom) / 2 * -1;
					var scrollTop = ((((self.element.offsetHeight - self.baseScrollTop) * self.minZoom) - (self.element.offsetHeight * self.transScale)) / self.minZoom) / 2 * -1;
					
					self.element.style.webkitTransitionDuration = '500ms';
					
					setTimeout(function()
						{
							self.element.style.webkitTransform = 'scale(' + self.minZoom + ') translate3d(' + scrollLeft + 'px, ' + scrollTop + 'px, 0px)';
						}, 100);
					
					self.imgHolder.className = self.imgHolder.className + ' _zoomHolder';
				}, 10);
			
			this.start();
			
			Ext.get(self.imgHolder).on('doubletap', function(e)
				{
					e.preventDefault();
					self.unZoom();
				});
			
			setTimeout(function()
				{
					self.options.onZoomReady();
					self.setLimits();
				}, 1500);
		},
	
	start: function()
		{
			var self = this;
			var x_tr;
			var y_tr;
			var startScale;
			var currentScale = self.getScale();
			
			if (Ext.is.Android)
				{
					var _touchstart = function(e)
						{
							if (e.target.tagName == 'A')
								{
									e.preventDefault();
								}
							
							startScale = self.getScale();
							self.element.style.webkitTransitionDuration = '0';
							self.translate(self.getTranslate().x, self.getTranslate().y);
							
							var X = e.touches[0].pageX;
							var Y = e.touches[0].pageY;
							
							x_tr = self.getTranslate().x;
							y_tr = self.getTranslate().y;
							
							X = X / e.touches.length / startScale;
							Y = Y / e.touches.length / startScale;
							x_tr -= X;
							y_tr -= Y;
						};
					
					this.imgHolder.addEventListener('touchstart', _touchstart);
					
					var x_start;
					var y_start;
					var time_start;
					var x_current;
					var y_current;
					var duration;
					
					var _touchmove = function(e)
						{
							e.preventDefault();
							
							var currentX = e.touches[0].pageX / startScale;
							var currentY = e.touches[0].pageY / startScale;
							
							self.translate(x_tr + currentX, y_tr + currentY);
						}
					
					this.imgHolder.addEventListener('touchmove', _touchmove);
					
					var _touchend = function(e)
						{
							self.chk();
						};
					
					this.imgHolder.addEventListener('touchend', _touchend);
				}
			else
				{
					var _gesturechange = function(e)
						{
							if (!app.zoomed)
								{
									return;
								}
							
							e.preventDefault();
							
							currentScale = startScale * e.scale;
							
							if (currentScale >= self.maxZoom)
								{
									self.scale(self.maxZoom);
								}
							else if (currentScale < (self.minZoom - .01))
								{
									self.unZoom();
									app.zoomed = false;
									
									e.stopPropagation();
									e.preventDefault();
								}
							else
								{
									self.scale(currentScale);
								}
						};
					
					this.imgHolder.addEventListener('gesturechange', _gesturechange);
					
					this.imgHolder.addEventListener('gestureend', function()
						{
							self.setLimits();
						});
					
					var x_start;
					var y_start;
					
					var _touchstart = function(e)
						{
							if (e.target.tagName == 'A')
								{
									e.preventDefault();
								}
							
							startScale = self.getScale();
							self.element.style.webkitTransitionDuration = '0';
							
							var obj_Translation = self.getTranslate();
							
							x_tr = obj_Translation.x - (e.touches[0].pageX / startScale);
							y_tr = obj_Translation.y - (e.touches[0].pageY / startScale);
							
							x_start = e.touches[0].clientX;
							Y_start = e.touches[0].clientY;
						};
					
					this.imgHolder.addEventListener('touchstart', _touchstart);
					
					var x_previous = x_start;
					var y_previous = y_start;
					var x_current;
					var y_current;
					var time_start = 0;
					var duration;
					var velocity_x;
					var velocity_y;
					
					var _touchmove = function(e)
						{
							e.preventDefault();
							
							var X = e.touches[0].pageX / startScale;
							var Y = e.touches[0].pageY / startScale;
							
							x_current = e.touches[0].clientX - x_previous;
							y_current = e.touches[0].clientY - y_previous;
							
							duration = e.timeStamp - time_start;
							
							velocity_x = x_current / (duration / 1000);
							velocity_y = y_current / (duration / 1000);
							
							x_previous = e.touches[0].clientX;
							y_previous = e.touches[0].clientY;
							
							time_start = e.timeStamp;
							
							self.translate(x_tr + X, y_tr + Y);
						}
					
					this.imgHolder.addEventListener('touchmove', _touchmove);
					
					var _touchend = function(e)
						{
							if (e.changedTouches.length == 1)
								{
									var transition_duration = Math.sqrt((Math.pow(velocity_x, 2) + Math.pow(velocity_y, 2)) / 2);
									self.element.style.webkitTransition = '-webkit-transform ' + transition_duration + 'ms cubic-bezier(0.1, 0.25, 0.1, 1.0)';
									
									var factor = 7;//(currentScale - self.minZoom + 1) / duration;
									var obj_Translation = self.getTranslate();
									
									var x_last = obj_Translation.x + (velocity_x / factor);
									var y_last = obj_Translation.y + (velocity_y / factor);
									
									var overflow = false;
									
									if (x_last > self.limitLeft)
										{
											x_last = self.limitLeft;
											overflow = true;
										}
									else if (x_last < self.limitRight)
										{
											x_last = self.limitRight;
											overflow = true;
										}
									
									if (y_last > self.limitTop)
										{
											y_last = self.limitTop;
											overflow = true;
										}
									else if (y_last < self.limitBottom)
										{
											y_last = self.limitBottom;
											overflow = true;
										}
									
									if (overflow)
										{
											self.element.style.webkitTransition = '-webkit-transform 500ms cubic-bezier(0.1, 0.25, 0.1, 1.0)';
										}
									
									self.translate(x_last, y_last);
								}
							else
								{
									self.chk();
								}
						};
					
					this.imgHolder.addEventListener('touchend', _touchend);
				}
		},
	
	unZoom: function()
		{
			this.element.style.webkitTransition = '-webkit-transform 600ms cubic-bezier(0.1, 0.25, 0.1, 1.0) !important';
			
			var self = this;
			
			window.scrollTo(0, 0);
			
			setTimeout(function()
				{
					try
						{
							for (var i = 0; i < self.imgLength; i++)
								{
									self.images[i].style.webkitTransform = '';
									document.getElementById('tmp').appendChild(self.images[i]);
									self.images[i].src = app.image_blank;
								}
							
							document.body.removeChild(self.imgHolder);
						}
					catch(e)
						{
							
						}
					
					self.options.onUnZoom();
					window.scrollTo(0, 0);
				}, 610);
			
			setTimeout(function()
				{	
					self.element.style.webkitTransform = 'scale(' + self.transScale + ') translate3d(' + self.baseScrollLeft + 'px, ' + self.baseScrollTop + 'px, 0)';
				}, 3);
		},
	
	scaleReg: /scale\(([0-9|\.]+)\)/,
	
	scale: function(scale)
		{
			this.element.style.webkitTransform = this.element.style.webkitTransform.replace(this.scaleReg, 'scale(' + scale + ')');
		},
	
	getScale: function()
		{
			return parseFloat(this.scaleReg.exec(this.element.style.webkitTransform)[1]);
		},
	
	translateReg: /translate3d\(([\-|0-9|\.|px]+)\,?\s?([\-|0-9|\.|px]*)\,?\s?([\-|0-9|\.|px]*)\)/,
	
	translate: function(x, y)
		{
			this.element.style.webkitTransform = this.element.style.webkitTransform.replace(this.translateReg, 'translate3d(' + x + 'px, ' + y + 'px, 0px)');
		},
	
	getTranslate: function()
		{
			var result = this.translateReg.exec(this.element.style.webkitTransform);
			
			return {
				str: result[0],
				x: parseFloat(result[1]),
				y: parseFloat(result[2])
			};
		},
	
	setLimits: function()
		{
			var sc = this.getScale();
			var img = this.element.querySelector('img');
			
			this.limitLeft = 0 - img.offsetLeft;
			this.limitTop = 0 - img.offsetTop;
			this.limitRight = Math.round((proportionsManager.getWidth() - ((this.element.offsetWidth - img.offsetLeft) * sc)) / sc);
			this.limitBottom = Math.round((proportionsManager.getHeight() - ((this.element.offsetHeight - img.offsetTop) * sc)) / sc);
		},
	
	chk: function()
		{
			if (Ext.is.Android)
				{
					return;
				}
			
			var tl = this.getTranslate();
			var tlX = Math.round(tl.x);
			var tlY = Math.round(tl.y);
			
			this.element.style.webkitTransitionDuration = '250ms';
			
			if (tlX > this.limitLeft)
				{
					tlX = this.limitLeft;
				}
			else if (tlX < this.limitRight)
				{
					tlX = this.limitRight;
				}
			
			if (tlY > this.limitTop)
				{
					tlY = this.limitTop;
				}
			else if (tlY < this.limitBottom)
				{
					tlY = this.limitBottom;
				}
			
			this.translate(tlX, tlY);
			var self = this;
		}
}